<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

$conf = array();

/***** Directories *****/
$conf['base_dir'] = dirname(dirname(dirname(__FILE__))) . '/';
$conf['system_dir'] = $conf['base_dir'] . 'avactis-system/';
$conf['modules_dir'] = $conf['system_dir'] . 'modules/';
$conf['cache_dir'] = $conf['system_dir'] . 'cache/';


/***** MySQL Engine *****/
$conf['mysql_table_engine'] = 'MyISAM'; // MyISAM | InnoDB


/***** Trace Log Settings *****/
// you may configure many trace loggers as you want
$conf['tracelog'] = array();

// default trace logger - log only err of wrn messages
// Note! Must be defined all values.
$conf['tracelog'][10] = array(
    'enabled' => 'yes',
    // any writable file
    'file' => $conf['cache_dir'] . '../cache/avactis_log',
    //"[@id] [@level] [@date @time.@microtime] [@delta_time] [@mem] [@delta_mem] [@filepath] [@file:@line] [@class@func()]";
    'template' => "[@id] [@level] [@date @time] [@class@func] [@file:@line]",
    'rotation' => array(
                    'size' => 1.0, // Megabytes
                    'rotate' => 10  // Integer
                )
);

// you may filter by 'level', 'file' (full path), 'func' and 'class'
// between fields will be applied AND rule, between field values will be applied OR rule
$conf['tracelog'][10]['filter'] = array(
    'level' => array('err', 'wrn')
);


/***** Profiler Settings *****/
$conf['profiler'] = array(
    'enabled' => 'no',
    'display_include' => 'no',
    'display_file_io' => 'no',
    'display_queries' => 'no',
);


/***** Gift Certificate Image *****/
$conf['gc_image_name'] = array(
    'largeimage' => 'gc.png',
    'smallimage' => 'gc.png'
);


/***** Cache Configuration ****/
$conf['cache_storages'] = array(
    'FILE' => array(
                'driver' => 'CCacheDriverFile',
                'args' => array(
                            0 => $conf['cache_dir'], // dir_storage
                        ),
            ),
    'SINGLE_FILE' => array(
                'driver' => 'CCacheDriverSingleFile',
                'args' => array(
                            0 => $conf['cache_dir'], // dir_storage
                            1 => 'global.common', // cache_file_label
                        ),
            ),
    'SINGLE_FILE_AZ' => array(
                'driver' => 'CCacheDriverSingleFile',
                'args' => array(
                            0 => $conf['cache_dir'], // dir_storage
                            1 => 'global.AdminZone', // cache_file_label
                        ),
            ),
    'SINGLE_FILE_CZ' => array(
                'driver' => 'CCacheDriverSingleFile',
                'args' => array(
                            0 => $conf['cache_dir'], // dir_storage
                            1 => 'global.CustomerZone', // cache_file_label
                        ),
            ),
    /*'MEMCACHED' => array(
                'driver' => 'CCacheDriverMemcached',
                'args' => array(
                            0 => '127.0.0.1', // host
                            1 => '11211', // port
                        ),
            ),*/
    'RAM'=> array(
                'driver' => 'CCacheDriverRAM',
            ),
    'NULL'=> array(
                'driver' => 'CCacheDriverNull',
            ),
);

$conf['cache'] = array(
    // FORMAT: 'namespace' => 'storage'

    // common:
    'persistent'    => 'FILE',
    'temporary'     => 'RAM',

    // special:
    'database'       => 'FILE',
    'templatesAZ'    => 'SINGLE_FILE_AZ',
    'modulesAZ'      => 'SINGLE_FILE_AZ',
    'templatesCZ'    => 'SINGLE_FILE_CZ',
    'modulesCZ'      => 'SINGLE_FILE_CZ',
    'inifiles'       => 'SINGLE_FILE',
    'hash'           => 'SINGLE_FILE',
    'attr_ids'       => 'SINGLE_FILE',
    'checkout'       => 'RAM',
);

// HTTP request variable name
$conf['variable_skin_name'] = 'scsbn';

/**
 * To activate combining, first run: avactis-system/admin/index.php?asc_action=combine_php
 * Drop combined files in emergency: avactis-system/admin/drop_combined_php.php
 */
$conf['preload_core_php'] = array(
    'combined_file' => dirname(dirname(__FILE__)).'/cache/combined.core.php',
    'files' => array(
        'core/PEAR.php',
        'core/Blowfish.php',
        'core/Blowfish/DefaultKey.php',
        'core/Blowfish/PHP.php',
        'core/Blowfish/MCrypt.php',
        'core/Blowfish/ECB.php',
        'core/RSA/ErrorHandler.php',
        'core/RSA/KeyPair.php',
        'core/RSA/Key.php',
        'core/RSA/MathLoader.php',
        'core/RSA.php',

        'core/CFileLock.php',
        'core/dbquery.php',
        'core/db_delete.php',
        'core/db_insert.php',
        'core/db_insert_select.php',
        'core/db_multiple_insert.php',
        'core/db_multiple_replace.php',
        'core/db_mysql_lock_tables.php',
        'core/db_mysql.php',
        'core/db_mysql_unlock_tables.php',
        'core/db_replace.php',
        'core/db_select.php',
        'core/db_table_clone.php',
        'core/db_table_create.php',
        'core/db_table_delete.php',
        'core/db_table_move.php',
        'core/db_update.php',

        'core/abstract/pm_sm_api.php',
        'core/abstract/pm_sm_input_az.php',
        'core/abstract/update_pm_sm_action.php',
        'core/action_message.php',
        'core/ajax_action.php',
        'core/application.php',

// new cache
        'core/ICacheStorage.php',
        'core/ICacheDriver.php',
        'core/CObject.php',
        'core/CCacheDriverNull.php',
        'core/CCacheDriverRAM.php',
        'core/CCacheDriverFile.php',
        'core/CCacheDriverMemcached.php',
        'core/CCacheDriverSingleFile.php',
        'core/CCacheItem.php',
        'core/CCacheStorage.php',
        'core/CCacheStorageWrapperNamespace.php',
        'core/CCacheFactory.php',

        'core/cdatetimeperiods.php',
        'core/cdatetime.php',
        'core/cstoredatetime.php',
        'core/request.php',
        'core/cz_request.php',
        'core/factory.php',
        'core/html_form.php',
        'core/image_obj.php',
        'core/io_disk.php',
        'core/JSON.php',
        'core/layout_configuration_manager.php',
        'core/message_resources.php',
        'core/multilang_core.php',
        'core/NullView.php',
        'core/phpSniff.core.php',
        'core/phpSniff.class.php',
        'core/query_executer.php',
        'core/replacer.php',
        'core/session_db.php',
        'core/session.php',
        'core/spyc.php',
        'core/tag_param_stack.php',
        'core/template_filler.php',
        'core/tmpl_filler.php',
        'core/tmpl_includer.php',
        'core/URI.class.php',
        'core/urlm.php',
        'core/UUIDUtils.php',
        'core/validator.php',
        'core/version.php',

        'modules/modules_manager/abstract/module_info.php',
        'modules/modules_manager/dbqueries/common.php',
        'modules/modules_manager/mm_api.php',
        'modules/resources/const.php',
        'modules/resources/resources_api.php',
        'modules/resources/dbqueries/common.php',
        'modules/multilang/multilang_api.php',
        'modules/multilang/dbqueries/common.php',
        'modules/configuration/const.php',
        'modules/configuration/configuration_api.php',
        'modules/configuration/abstract/settings.php',
        'modules/configuration/dbqueries/common.php',
        'modules/eventsmanager/events_manager_api.php',
    ),
);

$conf['preload_modules_php'] = array(
    'combined_file' => dirname(dirname(__FILE__)).'/cache/combined.modules.php',
    'files' => array(
        'modules/bestsellers_api/const.php',
        'modules/bestsellers_api/bestsellers_api.php',
        'modules/bestsellers_api/dbqueries/common.php',

        'modules/cart/cart_api.php',

        'modules/catalog/const.php',
        'modules/catalog/catalog_api.php',
        'modules/catalog/dbqueries/common.php',
        'modules/catalog/abstract/catalog_search.php',
        'modules/catalog/abstract/category_class.php',
        'modules/catalog/abstract/product_class.php',
        'modules/catalog/abstract/product_list_filter.php',
        'modules/catalog/abstract/product_list_tag_settings.php',
        'modules/catalog/actions/setcurrcat_action.php',

        'modules/charts/const.php',

        'modules/checkout/const.php',
        'modules/checkout/checkout_api.php',
        'modules/checkout/dbqueries/common.php',

        'modules/cms/abstract/cms_page_info.php',
        'modules/cms/cms_api.php',
        'modules/cms/const.php',
        'modules/cms/dbqueries/common.php',

        'modules/crypto/crypto_api.php',

        'modules/currency_converter/const.php',
        'modules/currency_converter/currency_converter_api.php',
        'modules/currency_converter/dbqueries/common.php',

        'modules/customer_account/const.php',
        'modules/customer_account/customer_account_api.php',
        'modules/customer_account/dbqueries/common.php',

        'modules/customer_reviews/const.php',
        'modules/customer_reviews/customer_reviews_api.php',
        'modules/customer_reviews/abstract/product_review_info.php',
        'modules/customer_reviews/dbqueries/common.php',

        'modules/data_converter/const.php',

        'modules/discounts/discounts_api.php',
        'modules/discounts/dbqueries/common.php',

        'modules/eventsmanager/dbqueries/common.php',

        'modules/featured_products/const.php',
        'modules/featured_products/featured_products_api.php',
        'modules/featured_products/dbqueries/common.php',

        'modules/gift_certificate/const.php',
        'modules/gift_certificate/gift_certificate_api.php',
        'modules/gift_certificate/abstract/gift_certificate_classes.php',
        'modules/gift_certificate/dbqueries/common.php',

        'modules/images/const.php',
        'modules/images/images_api.php',
        'modules/images/dbqueries/common.php',

        'modules/last_viewed_products/last_viewed_products_api.php',

        'modules/layout_cms/const.php',
        'modules/layout_cms/layout_cms_api.php',

        'modules/localization/const.php',
        'modules/localization/localization_api.php',
        'modules/localization/dbqueries/common.php',

        'modules/location/location_api.php',
        'modules/location/dbqueries/common.php',

        'modules/look_feel/const.php',
        'modules/look_feel/look_feel_api.php',

        'modules/manufacturers/const.php',
        'modules/manufacturers/manufacturers_api.php',
        'modules/manufacturers/dbqueries/common.php',

        'modules/mod_rewrite/const.php',
        'modules/mod_rewrite/mod_rewrite_api.php',
        'modules/mod_rewrite/dbqueries/common.php',

        'modules/modules_manager/actions/action_is_not_set.php',

        'modules/newsletter/const.php',
        'modules/newsletter/dbqueries/common.php',
        'modules/newsletter/newsletter_api.php',

        'modules/paginator/paginator_api.php',

        'modules/payment_module_chase_cc/const.php',
        'modules/payment_module_cod/payment_module_cod_api.php',
        'modules/payment_module_cyberbit_cc/dbqueries/common.php',
        'modules/payment_module_dibs_cc/const.php',
        'modules/payment_module_direct_deposit/payment_module_direct_deposit_api.php',
        'modules/payment_module_epdq_cc/const.php',
        'modules/payment_module_epn_cc/const.php',
        'modules/payment_module_eway_cc/const.php',
        'modules/payment_module_ideal_cc/const.php',
        'modules/payment_module_nexcommerce_cc/const.php',
        'modules/payment_module_offline_cc/dbqueries/common.php',
        'modules/payment_module_orbital_cc/const.php',
        'modules/payment_module_protx_direct_cc/const.php',
        'modules/payment_module_tranzila_cc/const.php',

        'modules/product_images/product_images_api.php',
        'modules/product_images/dbqueries/common.php',

        'modules/product_options/const.php',
        'modules/product_options/product_options_api.php',
        'modules/product_options/dbqueries/common.php',

        'modules/promocodes/const.php',
        'modules/promocodes/promo_codes_api.php',
        'modules/promocodes/dbqueries/common.php',

        'modules/quantity_discounts/const.php',
        'modules/quantity_discounts/quantity_discounts_api.php',
        'modules/quantity_discounts/dbqueries/common.php',

        'modules/related_products/const.php',
        'modules/related_products/related_products_api.php',
        'modules/related_products/dbqueries/common.php',

        'modules/reports/const.php',
        'modules/reports/reports_api.php',
        'modules/reports/abstract/report_data_collector.php',
        'modules/reports/dbqueries/common.php',
        'modules/reports/report-collectors/report_data_product_stat_collector.php',
        'modules/reports/report-collectors/report_data_visitors_stat_collector.php',

        'modules/shell/const.php',

        'modules/shipping_cost_calculator/const.php',
        'modules/shipping_cost_calculator/shipping_cost_calculator_api.php',
        'modules/shipping_cost_calculator/dbqueries/common.php',

        'modules/shipping_module_aup/dbqueries/common.php',
        'modules/shipping_module_cpc/dbqueries/common.php',
        'modules/shipping_module_dsr/dbqueries/common.php',
        'modules/shipping_module_fedex/dbqueries/common.php',
        'modules/shipping_module_flat_shipping_rates/dbqueries/common.php',
        'modules/shipping_module_freight101/dbqueries/common.php',
        'modules/shipping_module_intershipper/dbqueries/common.php',
        'modules/shipping_module_ups/dbqueries/common.php',
        'modules/shipping_module_usps/dbqueries/common.php',

        'modules/statistics/const.php',

        'modules/subscriptions/const.php',
        'modules/subscriptions/subscriptions_api.php',
        'modules/subscriptions/dbqueries/common.php',

        'modules/taxes/const.php',
        'modules/taxes/taxes_api.php',
        'modules/taxes/dbqueries/common.php',

        'modules/tax_exempts/const.php',
        'modules/tax_exempts/tax_exempts_api.php',
        'modules/tax_exempts/dbqueries/common.php',

        'modules/tax_rate_by_zip/dbqueries/common.php',

        'modules/timeline/const.php',
        'modules/timeline/dbqueries/common.php',
        'modules/timeline/timeline_api.php',

        'modules/transaction_tracking/const.php',
        'modules/transaction_tracking/transaction_tracking_api.php',
        'modules/transaction_tracking/dbqueries/common.php',

        'modules/users/users_api.php',
        'modules/users/dbqueries/common.php',

        'modules/wishlist/wishlist_api.php',
        'modules/wishlist/dbqueries/common.php',

        'modules/eventstack/event_stack_api.php',
        'modules/eventstack/dbqueries/common.php',

        'modules/most_viewed_products/most_viewed_products_api.php',
        'modules/most_viewed_products/dbqueries/common.php',

        'modules/rest/rest_api.php',
        'modules/rest/dbqueries/common.php',

        'modules/top_rated_products/top_rated_products_api.php',
        'modules/top_rated_products/dbqueries/common.php',
    ),
);

$conf['preload_modules_views_cz_php'] = array(
    'combined_file' => dirname(dirname(__FILE__)).'/cache/combined.modules.views.cz.php',
    'files' => array(
        'modules/bestsellers_api/views/bestsellers_cz.php',
        'modules/cart/views/cart_content.php',
        'modules/cart/views/cart_thumbnail.php',
        'modules/catalog/abstract/product_info.php',
        'modules/catalog/actions/setcurrprod_action.php',
        'modules/catalog/views/cat_breadcrumb_cz.php',
        'modules/catalog/views/cr_product_info_cz.php',
        'modules/catalog/views/navigation-bar-custom-cz.php',
        'modules/catalog/views/navigation-bar-cz.php',
        'modules/catalog/views/prodslist_cz.php',
        'modules/catalog/views/product_info_cz.php',
        'modules/catalog/views/product_list_sorter_cz.php',
        'modules/catalog/views/product_set_view.php',
        'modules/catalog/views/product_type_filter_cz.php',
        'modules/catalog/views/search_form_cz.php',
        'modules/catalog/views/search_result_cz.php',
        'modules/catalog/views/subcategories_cz.php',

        'modules/checkout/abstract/person_info_input_cz.php',
        'modules/checkout/abstract/person_info_output_cz.php',
        'modules/checkout/hooks/step_id_is_not_set.php',
        'modules/checkout/views/checkout-bank-account-info-input-cz.php',
        'modules/checkout/views/checkout-bank-account-info-output-cz.php',
        'modules/checkout/views/checkout-billing-info-input-cz.php',
        'modules/checkout/views/checkout-billing-info-output-cz.php',
        'modules/checkout/views/checkout-credit-card-info-input-cz.php',
        'modules/checkout/views/checkout-credit-card-info-output-cz.php',
        'modules/checkout/views/checkout-customer-info-input-cz.php',
        'modules/checkout/views/checkout-customer-info-output-cz.php',
        'modules/checkout/views/checkout-navigation-bar-cz.php',
        'modules/checkout/views/checkout-order-cz.php',
        'modules/checkout/views/checkout-shipping-info-input-cz.php',
        'modules/checkout/views/checkout-shipping-info-output-cz.php',
        'modules/checkout/views/checkout-shipping-methods-output.php',
        'modules/checkout/views/checkout-shipping-methods-select.php',
        'modules/checkout/views/checkout-step-link-cz.php',
        'modules/checkout/views/checkout-view-cz.php',
        'modules/checkout/views/one-step-checkout-cz.php',
        'modules/cms/views/cms_menu_cz.php',
        'modules/cms/views/cms_page_cz.php',
        'modules/cms/views/cms_page_tree_cz.php',

        'modules/cms/views/pageview_cz.php',
        'modules/customer_account/abstract/customer_info.php',
        'modules/customer_account/hooks/check_account_before_page_out.php',
        'modules/customer_account/views/auth_box_cz.php',
        'modules/customer_account/views/customer_change_password_form_cz.php',
        'modules/customer_account/views/customer_forgot_password_form_cz.php',
        'modules/customer_account/views/customer_home_page.php',
        'modules/customer_account/views/customer_new_password_form_cz.php',
        'modules/customer_account/views/customer_order_download_links_cz.php',
        'modules/customer_account/views/customer_order_info_cz.php',
        'modules/customer_account/views/customer_order_invoice_cz.php',
        'modules/customer_account/views/customer_order_list_cz.php',

        'modules/customer_account/views/customer_order_search_by_id_form_cz.php',
        'modules/customer_account/views/customer_order_search_form_cz.php',
        'modules/customer_account/views/customer_orders_history_cz.php',
        'modules/customer_account/views/customer_personal_info_cz.php',
        'modules/customer_account/views/reg_form_cz.php',
        'modules/customer_account/views/reg_msg_cz.php',
        'modules/customer_reviews/views/cr_product_add_review_form_cz.php',
        'modules/customer_reviews/views/cr_product_add_review_link_cz.php',
        'modules/customer_reviews/views/cr_product_detailed_rating_cz.php',
        'modules/customer_reviews/views/cr_product_rating_cz.php',
        'modules/customer_reviews/views/cr_product_review_list_cz.php',

        'modules/error/views/error_view.php',
        'modules/error/views/a_error.php',
        'modules/error/views/c_error.php',

        'modules/featured_products/views/featured_products_cz.php',
        'modules/gift_certificate/views/gc_add_cz.php',
        'modules/gift_certificate/views/gc_create_cz.php',
        'modules/images/views/image_output_cz.php',
        'modules/last_viewed_products/views/last_viewed_products_cz.php',
        'modules/localization/views/currency_selector_cz.php',
        'modules/manufacturers/views/manufacturer_info_cz.php',
        'modules/manufacturers/views/manufacturers_filter_cz.php',
        'modules/multilang/views/ml_select_language_cz.php',
        'modules/paginator/views/paginator_line.php',
        'modules/paginator/views/paginator_rows_per_page.php',
        'modules/product_files/views/download_product_file_prompt_cz.php',
        'modules/product_images/views/images_block_cz.php',
        'modules/product_options/views/options-choice-cz.php',
        'modules/product_options/views/options-combination-cz.php',
        'modules/product_options/views/options-warnings-cz.php',
        'modules/promocodes/views/promo_code_form_cz.php',
        'modules/related_products/views/related_products_cz.php',
        'modules/reports/views/one_tag_reports.php',
        'modules/shipping_cost_calculator/views/shipping_calculator_cz.php',
        'modules/subscriptions/abstract/subscribe_cz.php',
        'modules/subscriptions/views/subscribe_box_cz.php',
        'modules/subscriptions/views/subscribe_form_profile_cz.php',
        'modules/subscriptions/views/subscribe_on_checkout_cz.php',
        'modules/subscriptions/views/subscribe_on_checkout_output_cz.php',
        'modules/subscriptions/views/unsubscribe_by_link_cz.php',
        'modules/tax_exempts/views/full_tax_exempt_form_cz.php',
        'modules/transaction_tracking/views/transaction-tracking-html-code-cz.php',
        'modules/transaction_tracking/views/visitor-tracking-code-cz.php',
        'modules/wishlist/views/wl_add_to_wishlist_button_cz.php',
        'modules/wishlist/views/wl_send_wishlist_content_cz.php',
        'modules/wishlist/views/wl_wishlist_content_cz.php',

    ),
);
