<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package PaymentModuleChaseCC
 * @author Egor V. Derevyankin
 *
 */

class update_chase extends update_pm_sm
{
    function update_chase()
    {}

    function onAction()
    {
        global $application;
        parent::onAction();

        $request = new Request();

        $status = $request->getValueByKey('status');


        $name = $request->getValueByKey('MODULE_NAME');
        $cid = $request->getValueByKey('CHASE_MERCHANT_ID');
        $mode = $request->getValueByKey('MODULE_MODE');
        $bin = $request->getValueByKey('CHASE_BIN');

        $errors = array();

        if($status == "active")
        {
            //         ,       CheckoutFormEditor'
            //         PersonInfo     : BillingInfo, CreditCardInfo.
            if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "creditCardInfo")) === true)
            {
            }
            else
            {
                $status = "inactive";
                $errors[] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
            }
        }

        if(trim($name) == '')
        {
            $errors[] = 'MODULE_ERROR_NO_NAME';
        };

        if(trim($cid) == '')
        {
            $errors[] = 'MODULE_ERROR_NO_USERNAME';
        };

        if($mode != CHASE_MODE_PRODUCTION and $mode != CHASE_MODE_TEST)
        {
            $errors[] = 'MODULE_ERROR_INVALID_MODE';
        };

        if($bin != CHASE_BIN_SALEM and $bin != CHASE_BIN_TAMPA)
        {
            $errors[] = 'MODULE_ERROR_INVALID_BIN';
        };

        if(empty($errors))
        {
            modApiFunc('Checkout', 'setModuleActive',
                modApiFunc('Payment_Module_Chase_CC', 'getUid'),
                ($status == "active"));

            $settings = array(
                'MODULE_NAME' => $name
               ,'CHASE_MERCHANT_ID' => $cid
               ,'MODULE_MODE' => $mode
               ,'CHASE_BIN' => $bin
            );

            modApiFunc('Payment_Module_Chase_CC','updateSettings',$settings);
            $SessionPost = array(
                'ViewState' => array(
                    'hasCloseScript' => 'true'
                )
            );
        }
        else
        {
            $SessionPost = array(
                'ViewState' => array(
                    'ErrorsArray' => $errors
                   ,'hasCloseScript' => 'false'
                   ,'FormSubmitValue' => 'save'
                )
            );
        };

        $SessionPost['MODULE_NAME'] = $name;
        $SessionPost['MODULE_MODE'] = $mode;
        $SessionPost['CHASE_BIN'] = $bin;
        $SessionPost['CHASE_MERCHANT_ID'] = $cid;
        $SessionPost['status'] = $status;

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }
};

?>