<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package PaymentModuleChaseCC
 * @author Vadim Lyalikov
 *
 */

class CheckoutPaymentModuleChaseCCInput
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     *                                                     .
     */
    function getTemplateFormat()
    {
            $format = array(
                'layout-file'        => "checkout-payment-module-chase-cc-input-config.ini" //; $this->LayoutFile
               ,'files' => array(
                     'InputContainer'               => TEMPLATE_FILE_SIMPLE
                )
               ,'options' => array(
               )
            );
            return $format;
    }

    function CheckoutPaymentModuleChaseCCInput()
    {
        global $application;
        $this->HTML_LOCAL_TAGS_PREFIX = "Local_";
        #
        $this->NoView = false;
        if ($application->issetBlockTagFatalErrors($this->BlockTemplateName))
        {
            $this->NoView = true;
        }

        if ($application->getCurrentProtocol() == "http")
        {
            $this->NoView = "HTTPS_ERROR";
        }
        else
        {
            loadCoreFile('bouncer.php');
            $bssl = new Bouncer();
            if(!$bssl->isSSLavailable())
            {
                $this->NoView = "ERROR_SSL_NOT_AVAIL";
            }
        }
    }

    /**
     *
     */
    function output()
    {
        global $application;
        $ModuleInfo = modApiFunc($this->ModuleAPIClassName, "getInfo");
        $ModuleName = $ModuleInfo['Name'];

        if ($this->NoView)
        {
            if ($this->NoView == "HTTPS_ERROR")
            {
                $msg = &$application->getInstance("MessageResources");
                return $msg->getMessage(new ActionMessage(array("HTTPS_ERROR", $ModuleName)));
            }
            else if($this->NoView == "ERROR_SSL_NOT_AVAIL")
            {
                $msg = &$application->getInstance("MessageResources");
                return $msg->getMessage(new ActionMessage(array("SSL_ERROR", $ModuleName)));
            }
            return "";
        }

        $this->templateFiller = &$application->getInstance('TemplateFiller');
        $this->template = $application->getBlockTemplate($this->BlockTemplateName);
        $this->templateFiller->setTemplate($this->template);

        $this->_Template_Contents = array(
                 $this->HTML_LOCAL_TAGS_PREFIX . 'FormMethodIdFieldName' => ""
                ,$this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodID' => ""
                ,$this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodName' => ""
                ,$this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodIsChecked' => ""
                ,$this->HTML_LOCAL_TAGS_PREFIX . 'CreditCardInfoInput' => ""
                ,$this->HTML_LOCAL_TAGS_PREFIX . 'ErrorMessage' => ""
            );

        $application->registerAttributes($this->_Template_Contents);
        $retval = $this->templateFiller->fill("InputContainer");
        return $retval;
    }

    function getTag($tag)
    {
        global $application;
        $value = null;
        switch ($tag)
        {
            case $this->HTML_LOCAL_TAGS_PREFIX .'FormMethodIdFieldName':
                $value = "paymentModule[method_code]";
                break;

            case $this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodID':
                $ModuleInfo = modApiFunc($this->ModuleAPIClassName, "getInfo");
                $value = $ModuleInfo['GlobalUniquePaymentModuleID'];
                break;

            case $this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodName':
                $settings = modApiFunc($this->ModuleAPIClassName, "getSettings");
                $value = $settings['MODULE_NAME'];
                break;

            case $this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodIsChecked':
                $ModuleInfo = modApiFunc($this->ModuleAPIClassName, "getInfo");
                $pm_uuid = $ModuleInfo['GlobalUniquePaymentModuleID'];
                $checked = modApiFunc("Checkout", "isPaymentModuleChecked", $pm_uuid);
                $value = ($checked === true ? 'checked="checked"' : "");
                break;

            case $this->HTML_LOCAL_TAGS_PREFIX . 'CreditCardInfoInput':
                $pm_uuid = call_user_func(array($this->ModuleAPIClassName, "getUid"));
                $value = getCheckoutCreditCardInfoInput($pm_uuid);
                break;

            case $this->HTML_LOCAL_TAGS_PREFIX . 'ErrorMessage':
                if(modApiFunc('Session','is_set','Chase_ErrorMessage'))
                {
                    $value = modApiFunc('Session', 'get', 'Chase_ErrorMessage');
                    modApiFunc('Session','un_set','Chase_ErrorMessage');
                };
                break;

        }
        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */
    var $_Template_Contents;

    var $ModuleAPIClassName = "Payment_Module_Chase_CC";
    var $BlockTemplateName = "CheckoutPaymentModuleChaseCCInput";
    var $LayoutFile = "checkout-payment-module-chase-cc-input-config.ini";

    /**
     *         html      ,                           local           Person Info.
     */
    var $HTML_LOCAL_TAGS_PREFIX;// = "Local_";
    /**#@-*/
}
?>