<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModulehsbcCC
 * @author Yapharov Leonid
 */
class Payment_Module_hsbc_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'ACCEPTED'
                )
            )
        );
        return $res;
    }
    /**
     * PaymentModulehsbc constructor.
     */
    function Payment_Module_hsbc_CC()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-hsbc-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_LOG_MODULE_ID') . $info["GlobalUniquePaymentModuleID"] . "\n" .
        $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_LOG_MODULE_NAME') . $this->Settings["MODULE_NAME"];
    }


    function getmicrotime()
    {
        global $application;

        list($usec, $sec) = explode(" ",microtime());

        return $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_LOG_EVENT_TIME') . (float)($usec + $sec);
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_HSBC_CC::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $MessageResources = &$application->getInstance('MessageResources',"payment-module-hsbc-messages", "AdminZone");

        $tables = Payment_Module_hsbc_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_hsbc_settings';            #
        $columns = $tables[$table]['columns'];  #

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($MessageResources->getMessage('MODULE_NAME')).':"'.$MessageResources->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_HASH_KEY", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_STORE_FRONT_ID", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_CPI_URL", $columns['key']);
        $query->addInsertValue('s:32:"https://www.cpi.hsbc.com/servlet";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_hsbc_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_hsbc_CC                    2 PersonInfoType' :
     * billingInfo
     * shippingInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-hsbc-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }



    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "198EA7B5-FF44-8570-BFD4-943F85D57D47";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')."</span>":$this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "hsbc_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModuleHSBCCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleHSBCCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_hsbc_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settins array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_hsbc_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }


    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settins array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_hsbc_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_hsbc_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settins array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_hsbc_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_hsbc_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0 : number_format(($price*100),0,"","");
    }

    function os_detection()
    {
        if (_ml_stristr(PHP_OS, 'winnt') || _ml_stristr(PHP_OS, 'win32'))
        {
            $os = 'win';
        }
        elseif (_ml_stristr(PHP_OS, 'linux'))
        {
            $os = 'linux';
        }
//        elseif (_ml_stristr(PHP_OS, 'freebsd') || _ml_stristr(PHP_OS, 'aix') || _ml_stristr(PHP_OS, 'unix'))
//        {
//            $os = 'unix';
//        }
        elseif (_ml_stristr(PHP_OS, 'hp-ux'))
        {
            $os = 'hp-ux';
        }
        elseif (_ml_stristr(PHP_OS, 'sun'))
        {
            $os = 'sunos';
        }
        else
        {
            $os = null;
        }
        return $os;
    }

    function getHash($fields)
    {
        if (!($os = $this->os_detection()))
        {
            return;
        }

        $cmd="";
        // HSBC YCR Path to testhash.e executable ---- edit it to your own pathway to where you have put the files
        //Path where the TestHash.e executable is located ---- edit it to your own pathway to where you have put the files
        $path = dirname(__FILE__);
        $path.="/order_hash/".$os;
        reset($fields);
        while(list($k,$v)=each($fields))
        {
            $cmd.=" \"$v\" ";
        }
        //if you repeatedly get a hacking Attempt error check your website Error Log
        putenv("LD_LIBRARY_PATH=".$path);
        //Executes the TestHash to get the hash
        $cmd=$path."/TestHash.".($os == 'win'? "exe":"e")." \"".$this->Settings['MODULE_HASH_KEY']."\" ".$cmd." 2>&1";
        $ret=@exec($cmd, $output);
        if ($ret!="")
        {
            $ret=@explode(':',$ret);
            //Returns the hash
            $hash=@trim($ret[1]);
            return $hash;
        }
        else
        {
            return "";
        }
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile('aal.class.php');

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL("", true);

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());
        $currency = $this->MessageResources->getMessage('CURRENCY_CODE_'.modApiFunc("Localization", "getCurrencyCodeById", $currency_id));

        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, $currency_id);

        $billingInfo = new ArrayAccessLayer($orderInfo);
        $billingInfo->setAccessMask ("Billing",  "attr", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer($orderInfo);
        $shippingInfo->setAccessMask ("Shipping",  "attr", AAL_CUSTOM_PARAM, "value");

        $billingCountry = $billingInfo->getByMask('Country')? $this->MessageResources->getMessage('COUNTRY_CODE_'.modApiFunc("Location", "getCountryCodeByCountryName", $billingInfo->getByMask('Country'))):"826";

        $shippingCountry = $shippingInfo->getByMask('Country')? $this->MessageResources->getMessage('COUNTRY_CODE_'.modApiFunc("Location", "getCountryCodeByCountryName", $shippingInfo->getByMask('Country'))):"826";

        list($usec, $sec) = explode(" ", microtime());
        $timestamp = (float)(($usec + $sec)*1000);
        $timestamp+= modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_TIME_SHIFT)*3600*1000;
        $timestamp = sprintf("%f", $timestamp);
        $timestamp = _ml_substr($timestamp, 0, _ml_strpos($timestamp, "."));

        $this->getSettings();
        $confirmationData = array
            (
                "FormAction" => $this->Settings['MODULE_CPI_URL']
               ,"FormMethod" => "POST"
               ,"DataFields" => array
                    (
//                        "CpiUrl" => $this->Settings['MODULE_CPI_URL']
                        "CpiDirectResultUrl" => $self_link
                       ,"CpiReturnUrl" => $self_link ."&status=return"
                       ,"MerchantData" => session_id()
                       ,"Mode" => ($this->Settings["MODULE_MODE"] == "2"? "P":"T")
                       ,"OrderDesc" => modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_NAME)
                       ,"OrderId" => $orderId
                       ,"PurchaseAmount" => $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid())))
                       ,"PurchaseCurrency" => $currency
                       ,"StorefrontId" => $this->Settings['MODULE_STORE_FRONT_ID']
                       ,"TimeStamp" => $timestamp
                       ,"TransactionType" => "Capture"
                       ,"UserId" => "NA"

                       ,"BillingAddress1" => $billingInfo->getByMask('Streetline1')
                       ,"BillingAddress2" => $billingInfo->getByMask('Streetline2')
                       ,"BillingCity" => $billingInfo->getByMask('City')
                       ,"BillingCountry" => $billingCountry
                       ,"BillingCounty" => $billingInfo->getByMask('State')
                       ,"BillingFirstName" => $billingInfo->getByMask('Firstname')
                       ,"BillingLastName" => $billingInfo->getByMask('Lastname')
                       ,"BillingPostal" => $billingInfo->getByMask('Postcode')

                       ,"ShopperEmail" => modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_EMAIL)

                       ,"ShippingAddress1" => $shippingInfo->getByMask('Streetline1')
                       ,"ShippingAddress2" => $shippingInfo->getByMask('Streetline2')
                       ,"ShippingCity" => $shippingInfo->getByMask('City')
                       ,"ShippingCountry" => $shippingCountry
                       ,"ShippingCounty" => $shippingInfo->getByMask('State')
                       ,"ShippingFirstName" => $shippingInfo->getByMask('Firstname')
                       ,"ShippingLastName" => $shippingInfo->getByMask('Lastname')
                       ,"ShippingPostal" => $shippingInfo->getByMask('Postcode')
                    )
            );

        $confirmationData["DataFields"]["OrderHash"]=$this->getHash($confirmationData["DataFields"]);

        return $confirmationData;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id /*, &$DBPaymentStatus, &$bStop, &$bPaymentFinished, &$EventType */)
    {

        //the first step of data processing from the Payment Gateway
        //the payment status update.
        //the next step.
        //do not call the Payment Gateway .
        // Waiting 9
        // FullyPaid 0
        // Daclined  1,2,3,4,5,6,7,8,10,11,12,13,14,15,16
        $DBPaymentStatus = array();
        $order_status = isset($data["_GET"]["status"])? $data["_GET"]["status"]:"";
        $ret_code = isset($data["_POST"]["CpiResultsCode"])? $data["_POST"]["CpiResultsCode"]:"";
        if (intval($ret_code)==9)
        {
            $order_status="waiting";
        }
        elseif (intval($ret_code)==0)
        {
            $order_status="fully_paid";
        }
        elseif ((intval($ret_code)>=1)&&(intval($ret_code)<=16)&&(intval($ret_code)!=9))
        {
            $order_status="declined";
        }

        switch ($order_status)
        {
            case "return":
                $EventType = "ConfirmationSuccess";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 1,
                $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_LOG_EVENT_DESCRIPTION') . $this->MessageResources->getMessage('PAYMENT_1_RETURN_MSG') . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_LOG_POST_DATA') . "\n" . print_r($data["_POST"], true));
                break;
                break;
            case "waiting":
                $EventType = "ConfirmationSuccess";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 1,
                $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_LOG_EVENT_DESCRIPTION') . $this->MessageResources->getMessage('PAYMENT_'.$ret_code.'_RETURN_MSG') . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_LOG_POST_DATA') . "\n" . print_r($data["_POST"], true));
                break;
            case "fully_paid":
                $EventType = "ConfirmationSuccess";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2,
                $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_LOG_EVENT_DESCRIPTION') . $this->MessageResources->getMessage('PAYMENT_'.$ret_code.'_RETURN_MSG') . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_LOG_POST_DATA') . "\n" . print_r($data["_POST"], true));
                break;
            case "declined":
                $EventType = "ConfirmationFailure";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_LOG_EVENT_DESCRIPTION') . $this->MessageResources->getMessage('PAYMENT_'.$ret_code.'_RETURN_MSG') . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_HSBC_LOG_POST_DATA') . "\n" . print_r($data["_POST"], true));
                break;
        }
        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_hsbc_CC::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_hsbc_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_hsbc_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_hsbc_setting_id'
               ,'key'               => $settings.'.pm_hsbc_setting_key'
               ,'value'             => $settings.'.pm_hsbc_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>