<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

define("MERCHANT_EQUIPMENT_STORE_URL", "secure.networkmerchants.com/gw/api/transact.php");

define("MERCHANT_EQUIPMENT_STORE_TEST_USERNAME", "demo");
//define("MERCHANT_EQUIPMENT_STORE_TEST_PASSWORD", "password");

/**
 *
 * @package PaymentModuleMerchantEquipmentStoreCC
 * @author Egor Makarov
 */
class Payment_Module_Merchant_Equipment_Store_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     *  Payment_Module_Merchant_Equipment_Store_CC constructor
     */
    function Payment_Module_Merchant_Equipment_Store_CC()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-merchant-equipment-store-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->CCInfo = array();

        $this->getSettings();
        $this->Response = array("response" => "3");

        $this->OrderHistoryMessageTag = $this->MessageResources->getMessage('MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
        $this->errorMessage = null;
    }


    function getmicrotime()
    {
        global $application;
        list($usec, $sec) = explode(" ", microtime());

        return $this->MessageResources->getMessage('MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $this->MessageResources->getMessage('MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_SECONDS');
    }

    /**
     *                                     .
     *
     *       install()                      .
     *
     *                                          ,         ,
     * Payment_Module_Paypal_CC::getTables()        $this->getTables()
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-merchant-equipment-store-messages", "AdminZone");

        $tables = Payment_Module_Merchant_Equipment_Store_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_merchant_equipment_store_settings';            //
        $columns = $tables[$table]['columns'];        //

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

/*
        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_DESCR", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_DESCR')).':"'.$obj->getMessage('MODULE_DESCR').'";', $columns['value']);
        $application->db->getDB_Result($query);
*/

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_USERNAME", $columns['key']);
        $query->addInsertValue('s:8:"username";', $columns['value']);
        $application->db->getDB_Result($query);

/*
        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_PASSWORD", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);
*/

/*
        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_TRANSACTION_TYPE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);
*/

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Merchant_Equipment_Store_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_Merchant_Equipment_Store_CC                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-merchant-equipment-store-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_MERCHANT_EQUIPMENT_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }



    /**
     *                      Checkout   CZ.           AZ.
     *   .                            -
     *                   Checkout   CZ.
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "BF2896EC-662B-A780-F1AB-14475CE6F0A4";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => Payment_Module_Merchant_Equipment_Store_CC::getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "Description" => $this->MessageResources->getMessage("MODULE_DESCR"),
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')."</span>":$this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "CheckoutPaymentModuleMerchantEquipmentStoreCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModuleMerchantEquipmentStoreCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleMerchantEquipmentStoreCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'MerchantEquipmentStoreErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'MerchantEquipmentStoreErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'MerchantEquipmentStoreErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMessage($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMessage()
    {
        return $this->errorMessage;
    }

    function unsetErrorMessage()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'MerchantEquipmentStoreErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'MerchantEquipmentStoreErrorMessage');
        }
    }

    /**
     *                 Settings
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_merchant_equipment_store_settings');
        $application->db->getDB_Result($query);
    }

    /**
     *                                               Settings
     *
     * @return array -
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_merchant_equipment_store_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }


    /**
     *                          -
     *
     * @param array $Settings -                        .
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_merchant_equipment_store_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_merchant_equipment_store_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     *                          -
     *
     * @param array $Settings -                        .                    ,                   ,
     *                       .
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_merchant_equipment_store_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_merchant_equipment_store_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     *                      Checkout.
     *                .             0                 payment        .
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     *                                                       _   _ ASC.
     *                 PRICE_N_A,                      0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     *                                    'derect' or 'redirect'
     */
    function getPaymentMode()
    {
        return "direct";
    }

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        //           -                     PersonInfo Variant'    -         /        ...
        if($prerequisite_type == "creditCardInfo")
        {
            return "default";
        }
        else
        {
            return false;
        }
    }

    function backgroundProcess($type="direct", $transactionData = null)
    {
        global $application;
        loadCoreFile('aal.class.php');

        $Settings = $this->getSettings();
        $msg = &$application->getInstance('MessageResources',"payment-module-merchant-equipment-store-messages", "AdminZone");

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currency = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);
        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());
        //:                 $CCInfo             false.                                          .

        if ($Settings["MODULE_MODE"] == "2")
        {
            $merchantUserName = $Settings["MODULE_USERNAME"];
//            $merchantPassword = $Settings["MODULE_PASSWORD"];
        }
        else
        {
            $merchantUserName = MERCHANT_EQUIPMENT_STORE_TEST_USERNAME;
//            $merchantPassword = MERCHANT_EQUIPMENT_STORE_TEST_PASSWORD;
        }

/*
        switch ($Settings["MODULE_TRANSACTION_TYPE"])
        {
            case "1" : $transType = "sale"; break;
            case "2" : $transType = "auth"; break;
            case "3" : $transType = "credit"; break;
        }
*/


        $dataFields = array
        (
             "type"      => "sale"//$transType
            ,"username"  => $merchantUserName
//            ,"password"  => $merchantPassword
            ,"ccnumber"  => $CCInfo["CreditCardNumber"]["value"]
            ,"ccexp"     => $CCInfo["ExpirationMonth"]["value"] . _ml_substr($CCInfo["ExpirationYear"]["value"], 2, 2)
            ,"amount"    => number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "GetOrderPrice", "Total", $currency_id)), 2, ".", "")
            ,"cvv"       => $CCInfo["CreditCardVerificationNumber"]["value"] ? $CCInfo["CreditCardVerificationNumber"]["value"] : ""
            ,"orderid"   => ""
            ,"orderdescription" => modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_NAME)
            ,"ipaddress" => $_SERVER['REMOTE_ADDR']
            ,"tax"       => number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "NotIncludedTax", $currency_id)), 2, '.', ',')
            ,"shipping"  => number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost", $currency_id)), 2, '.', ',')
            ,"ponumber"  => ""
            ,"firstname" => $billingInfo->getByMask('Firstname')
            ,"lastname"  => $billingInfo->getByMask('Lastname')
            ,"company"   => ""
            ,"address1"  => $billingInfo->getByMask('Streetline1')
            ,"address2"  => $billingInfo->getByMask('Streetline2')
            ,"city"      => $billingInfo->getByMask('City')
            ,"state"     => $billingInfo->getByMask('Statemenu')? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')): $billingInfo->getByMask('Statetext')
            ,"zip"       => $billingInfo->getByMask('Postcode')
            ,"country"   => $billingInfo->getByMask('Country')? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')):""
            ,"phone"     => $billingInfo->getByMask('Phone')
            ,"fax"       => ""
            ,"email"     => $billingInfo->getByMask('Email')
            ,"website"   => ""
            ,"shipping_firstname"   => $shippingInfo->getByMask('Firstname')
            ,"shipping_lastname"   => $shippingInfo->getByMask('Lastname')
            ,"shipping_company"   => ""
            ,"shipping_address1"   => $shippingInfo->getByMask('Streetline1')
            ,"shipping_address2"   => $shippingInfo->getByMask('Streetline2')
            ,"shipping_city"   => $shippingInfo->getByMask('City')
            ,"shipping_state"   => $shippingInfo->getByMask('Statemenu')? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')): $shippingInfo->getByMask('Statetext')
            ,"shipping_zip"   => $shippingInfo->getByMask('Postcode')
            ,"shipping_country"   => $shippingInfo->getByMask('Country')? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')):""
            ,"shipping_email"   => $shippingInfo->getByMask('Email')
        );

        $dataFields = array_filter($dataFields);

        loadCoreFile('bouncer.php');
        $bouncer = new Bouncer();
        $postString = $bouncer->prepareDATAstring($dataFields);
        $bouncer->setMethod("POST");
        $bouncer->setURL('https://'.MERCHANT_EQUIPMENT_STORE_URL);
        $bouncer->setPOSTstring($postString);
        $textResponse = $bouncer->RunRequest();

        if (isset($textResponse["body"]))
        {
        	$responseArray = explode("&", $textResponse["body"]);
        	foreach ($responseArray as $entry)
        	{
        	    list($key, $val) = explode("=", $entry);
        	    $this->Response[$key] = urldecode($val);
        	}
        }
        else
        {
            $this->setErrorMessage($msg->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_ERROR_CONNECTION_ERROR") . ":" . $bouncer->getLastErrorMessage());
        }

        $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID");
        switch ($this->Response["response"])
        {
            case "1": // Accepted
                //Create order
                $order_id = modApiFunc("Checkout", "createOrderInDB");
                //                .
                //
                modApiFunc("Cart", "removeAllFromCart");
                $this->processData(array("_POST" => $this->Response, "_GET" => array()), $order_id);
                $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
                break;
            case "2": // Declined
            case "3": // Error
            default:
                if ($this->Response["response"] == "2")
                {
                    $this->setErrorMessage($msg->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_MESSAGE_DECLINED")."\"".$this->Response["responsetext"]."\"");
                }
                elseif ($this->Response["response"] == "3")
                {
                    $this->setErrorMessage($msg->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_MESSAGE_ERROR")."\"".$this->Response["responsetext"]."\"");
                }
                else
                {
                    $this->setErrorMessage($msg->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_ERROR_UNKNOWN_RESPONSE") . "\"" . $responseParams["response"] . "\"");
                }
                $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
                modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
                $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
                modApiFunc("Checkout", "saveState");
                break;
        }

        $request = new Request();
        $request->setView('CheckoutView');
        $request->setAction("SetCurrStep");
        $request->setKey   ( 'step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    /**
     *                                               ,                              .
     *      &$bStop                                  .         true                         ,
     *           Checkout                                  [                   ].
     */
    function processData($data, $order_id /*, &$DBPaymentStatus, &$bStop, &$bPaymentFinished, &$EventType */)
    {
        global $application;
        $status = $data["_POST"]["response"];

        //
        modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $data["_POST"]["transactionid"]);

        $avsResultText = array_key_exists("avsresponse", $data["_POST"]) ?
            $this->MessageResources->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_MESSAGE_AVSRES_" . $data["_POST"]["avsresponse"]) : $this->MessageResources->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_MESSAGE_AVSRES_NO");

        $cvvResulrText = array_key_exists("cvvresponse", $data["_POST"]) ?
            $this->MessageResources->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_MESSAGE_CVVRES_" . $data["_POST"]["avsresponse"]) : $this->MessageResources->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_MESSAGE_CVVRES_NO");

        $msg = $this->OrderHistoryMessageTag . "\n" .
              $this->getmicrotime() . "\n" .
              $this->MessageResources->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_EVENT_DESCRIPTION") . $this->MessageResources->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_MESSAGE_ACCEPTED") . "\n" .
              $this->MessageResources->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_MESSAGE_AVSRESULT") . $avsResultText . "\n" .
              $this->MessageResources->getMessage("MODULE_PAYMENT_MERCHANT_EQUIPMENT_STORE_LOG_MESSAGE_CVVRESULT") . $cvvResulrText;

        switch ($status)
        {
            case '1':
                $EventType = "ConfirmationSuccess";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
                break;
            case '2':
            case '3':
                $EventType = "ConfirmationFailure";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
                break;
            default:
                //: Report Error: e.g. write to order history
                $result = array("payment_status" => array());
                break;
        }
        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstall the module.
     *                           .
     *
     *       uninstall()                      .
     *
     *                                          ,         ,
     * Payment_Module_Paypal_CC::getTables()        $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Merchant_Equipment_Store_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     *
     *
     *                                        :
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       #                                            ,          - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      #                                                   ,          - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_merchant_equipment_store_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_merchant_equipment_store_setting_id'
               ,'key'               => $settings.'.pm_merchant_equipment_store_setting_key'
               ,'value'             => $settings.'.pm_merchant_equipment_store_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $CCInfo;

    var $PaymentProcessingResult;

    var $PaymentStatusChangeResult;

    /**
     *     .              .                ,
     * CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>