<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * moneybooewallet_cc_input_az view
 *
 * @package PaymentModuleMoneybooewalletCC
 * @author Ravil Garafutdinov
 */
class CheckoutPaymentModuleMoneybooewalletCCInputAZ extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Modules_Manager constructor.
     */
    function CheckoutPaymentModuleMoneybooewalletCCInputAZ()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-moneybooewallet-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->mTmplFiller = &$application->getInstance('TmplFiller');
        $this->settings = modApiFunc('Payment_Module_Moneybooewallet_CC', 'getSettings');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }
    }

    /**
     * Initializes data from the POST array.
     */
    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];

        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        if(isset($this->ViewState["MailMessage"]))
        {
            $this->MailMessage = $this->ViewState["MailMessage"];
            unset($this->ViewState["MailMessage"]);
        }

        $this->POST = $SessionPost;

        if (!isset($this->POST['status']))
        {
            $this->POST['status'] = 0;
        }
        if (!isset($this->POST['ModuleCustomerId']))
        {
            $this->POST['ModuleCustomerId'] = $this->settings['MODULE_CUSTOMER_ID'];
        }
        if (!isset($this->POST['ModuleMerchantEmailValidated']))
        {
            $this->POST['ModuleMerchantEmailValidated'] = $this->settings['MODULE_MERCHANT_EMAIL_VALIDATED'];
        }
        if (!isset($this->POST['ModuleSecretStringValidated']))
        {
            $this->POST['ModuleSecretStringValidated'] = $this->settings['MODULE_SECRET_STRING_VALIDATED'];
        }
    }

    /**
     * Initializes data from the database.
     */
    function initFormData()
    {
        $this->POST = array();
        foreach ($this->settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME":              $this->POST["ModuleName"] = $value; break;
                case "MODULE_MERCHANT_EMAIL":    $this->POST["ModuleMerchantEmail"] = $value; break;
                case "MODULE_MERCHANT_EMAIL_VALIDATED": $this->POST["ModuleMerchantEmailValidated"] = $value; break;
                case "MODULE_CUSTOMER_ID":       $this->POST["ModuleCustomerId"] = $value; break;
                case "MODULE_SECRET_STRING":     $this->POST["ModuleSecretString"] = $value; break;
                case "MODULE_SECRET_STRING_VALIDATED": $this->POST["ModuleSecretStringValidated"] = $value; break;
                case "MODULE_MERCHANT_NAME":     $this->POST["ModuleMerchantName"] = $value; break;
                case "MODULE_HIDE_LOGIN":        $this->POST["ModuleHideLogin"] = $value; break;
                case "MODULE_LOGO_URL":          $this->POST["ModuleLogoUrl"] = $value; break;
                case "MODULE_LANGUAGE":          $this->POST["ModuleLanguage"] = $value; break;
                case "MODULE_URL":               $this->POST["ModuleUrl"] = $value; break;
            }
        }
        $this->POST["status"] = modApiFunc("Payment_Module_Moneybooewallet_CC", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );
    }

    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * Outputs errors.
     */
    function outputErrors()
    {
        global $application;
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }
        $result = "";
        $application->registerAttributes(array('ErrorIndex', 'Error'));
        $this->_error_index = 0;
        foreach ($this->ErrorsArray as $error)
        {
            $this->_error_index++;
            $this->_error = $this->MessageResources->getMessage($error);
            $result .= $this->mTmplFiller->fill("payment_module_moneybooewallet/", "error.tpl.html", array());
        }
        return $result;
    }

    function outputEmailSentMessage()
    {
        global $application;
        if (isset($this->MailMessage) && $this->MailMessage != null)
        {
            return getMsg('PM_MBK_CC', $this->MailMessage);
        }

        return '';
    }

    /**
     * Outputs the module status.
     */
    function outputStatus()
    {
        global $application;
        $retval = "";
        $status = $this->POST["status"];

        $msg = '';
        $disabled = '';
        $hidden = '';
        if ($this->POST['ModuleMerchantEmailValidated'] == 0
            || $this->POST['ModuleSecretStringValidated'] == 0
            || $this->POST["ModuleCustomerId"] = ''
        )
        {
            $status = 0;
            $msg = getMsg('PM_MBK_CC', 'MODULE_STATUS_WARNING');
            $disabled = 'disabled="DISABLED"';
            $hidden = "<input type='hidden' name='status' value='0' />";
        }

        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked" : ""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "" : "checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         ,"Disabled"        => $disabled
                                         ,"Hidden"          => $hidden
                                         ,"Message"         => $msg
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_moneybooewallet/", "status.tpl.html", array());
        return $retval;
    }

    /**
     *
     */
    function outputOrderStatus()
    {
        global $application;
        $retval = "";
        for ($i=1; $i<5; $i++)
        {
            $retval.= "<option value=\"$i\" ";
            $retval.= ($this->POST["ModuleOrderStatusId"] == $i)? "SELECTED " : "";
            $retval.= ">" . $this->MessageResources->getMessage('MODULE_ORDER_STATUS_00'.$i) . "</option>";
        }
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_moneybooewallet/", "status.tpl.html", array());
        return $retval;
    }


    /**
     * outputs Hide Login select options
     *
     * @return "<options>"
     */
    function outputHideLoginOptions()
    {
        $ret = '';
        $variants = array('0' => getMsg('PM_MBK_CC', 'NO_LABEL'), '1' => getMsg('PM_MBK_CC', 'YES_LABEL'));
        foreach ($variants as $key => $value)
        {
            if ($key == $this->POST["ModuleHideLogin"])
            {
                $selected = " selected";
            }
            else
            {
                $selected = '';
            }
            $ret .= "<option value='$key'$selected>$value";
        }
        return $ret;
    }

    /**
     * outputs Client Language select options
     *
     * @return "<options>"
     */
    function outputLanguageOptions()
    {
        $ret = '';
        $lang = array('EN', 'DE', 'ES', 'FR', 'IT', 'PL', 'GR', 'RO', 'RU', 'TR', 'CN', 'CZ', 'NL', 'DA', 'SV', 'FI');
        foreach ($lang as $l)
        {
            if ($l == $this->POST["ModuleLanguage"])
            {
                $selected = " selected";
            }
            else
            {
                $selected = '';
            }
            $ret .= "<option value='$l'$selected>$l";
        }
        return $ret;
    }

    /**
     *
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "UpdateParent");
        }

        $request = new Request();
        $request->setView('CheckoutPaymentModuleSettings');
        $request->setAction("update_moneybooewallet");
        $form_action = $request->getURL();

        $customer_id = ($this->POST["ModuleCustomerId"] != '')
            ?
            $this->POST["ModuleCustomerId"]
            :
            getMsg('PM_MBK_CC', 'EMAIL_NOT_CHECKED_YET');

        $template_contents = array(
                                    "EditMoneybooewalletForm"        => $HtmlForm1->genForm($form_action, "POST", "EditMoneybooewalletForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"Errors"                => $this->outputErrors()

                                   ,"ModuleStatusFieldName" => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                                   ,"ModuleStatusFieldHint" => $this->Hints->getHintLink(array('MODULE_STATUS_FIELD_NAME', 'payment-module-moneybooewallet-messages'))
                                   ,"ModuleStatusField"     => $this->outputStatus()

                                   ,"ModuleMethodNameFieldName"   => $this->MessageResources->getMessage('MODULE_METHOD_NAME_FIELD_NAME')
                                   ,"ModuleNameFieldHint"   => $this->Hints->getHintLink(array('MODULE_METHOD_NAME_FIELD_NAME', 'payment-module-moneybooewallet-messages'))
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "ModuleName", "75", prepareHTMLDisplay($this->POST["ModuleName"]))

                                   ,"ModuleMerchantNameFieldHint"  => $this->Hints->getHintLink(array('MODULE_MERCHANT_NAME_FIELD_NAME', 'payment-module-moneybooewallet-messages'))
                                   ,"ModuleMerchantNameField"      => $HtmlForm1->genInputTextField("128", "ModuleMerchantName", "30", prepareHTMLDisplay($this->POST["ModuleMerchantName"]))

                                   ,"ModuleMerchantEmailFieldHint"  => $this->Hints->getHintLink(array('MODULE_MERCHANT_EMAIL_FIELD_NAME', 'payment-module-moneybooewallet-messages'))
                                   ,"ModuleMerchantEmailField"      => $HtmlForm1->genInputTextField("128", "ModuleMerchantEmail", "30", prepareHTMLDisplay($this->POST["ModuleMerchantEmail"]))
                                   ,"IsEmailValidated"              => ($this->POST["ModuleMerchantEmailValidated"] == 1) ? getMsg('PM_MBK_CC', 'VALIDATED_LABEL') : ''

                                   ,"ModuleCustomerIdFieldHint"  => $this->Hints->getHintLink(array('MODULE_CUSTOMER_ID_FIELD_NAME', 'payment-module-moneybooewallet-messages'))
                                   ,"ModuleCustomerIdField"      => $customer_id

                                   ,"ModuleEmailSentMessage"     => $this->outputEmailSentMessage()

                                   ,"ModuleSecretStringFieldHint"  => $this->Hints->getHintLink(array('MODULE_SECRET_STRING_FIELD_NAME', 'payment-module-moneybooewallet-messages'))
                                   ,"ModuleSecretStringField"      => $HtmlForm1->genInputTextField("128", "ModuleSecretString", "30", prepareHTMLDisplay($this->POST["ModuleSecretString"]))
                                   ,"IsSecretStringValidated"      => ($this->POST["ModuleSecretStringValidated"] == 1) ? getMsg('PM_MBK_CC', 'VALIDATED_LABEL') : ''

                                   ,"ModuleUrlFieldHint"  => $this->Hints->getHintLink(array('MODULE_URL_FIELD_NAME', 'payment-module-moneybooewallet-messages'))
                                   ,"ModuleUrlField"      => $HtmlForm1->genInputTextField("128", "ModuleUrl", "30", prepareHTMLDisplay($this->POST["ModuleUrl"]))

                                   ,"ModuleHideLoginFieldHint"    => $this->Hints->getHintLink(array('MODULE_HIDE_LOGIN_FIELD_NAME', 'payment-module-moneybooewallet-messages'))
                                   ,"ModuleHideLoginOptions"      => $this->outputHideLoginOptions()

                                   ,"ModuleLogoUrlFieldHint"  => $this->Hints->getHintLink(array('MODULE_LOGO_URL_FIELD_NAME', 'payment-module-moneybooewallet-messages'))
                                   ,"ModuleLogoUrlField"      => $HtmlForm1->genInputTextField("128", "ModuleLogoUrl", "30", prepareHTMLDisplay($this->POST["ModuleLogoUrl"]))

                                   ,"ModuleLanguageFieldHint"    => $this->Hints->getHintLink(array('MODULE_LANGUAGE_FIELD_NAME', 'payment-module-moneybooewallet-messages'))
                                   ,"ModuleLanguageOptions"      => $this->outputLanguageOptions()

                                   ,"Alert_001"             => $this->MessageResources->getMessage('ALERT_001')
                                   ,"Alert_002"             => $this->MessageResources->getMessage('ALERT_002')
                                   ,"Alert_003"             => $this->MessageResources->getMessage('ALERT_003')
                                   ,"Alert_004"             => $this->MessageResources->getMessage('ALERT_004')

                                   ,"PmSmAcceptedCurrencies" => $this->outputAcceptedCurrencies()

                               );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("payment_module_moneybooewallet/", "list.tpl.html", array());
    }

    /**
     * Returns the tag output, the name of which was specified in $tag.
     */
    function getTag($tag)
    {
        global $application;
        $value = "";

        if ($tag == "Error")
        {
            $value = $this->_error;
        }
        elseif ($tag == "ErrorIndex")
        {
            $value = $this->_error_index;
        }
        else
        {
            $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
        }

        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;

    /**
     * View state structure. It comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>    "LargeImage"      = "image.jpg"       //
     * <br>    "SmallImage"      = "image_small.jpg" //
     * <br>)
     */
    var $ViewState;
    var $settings;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    /**#@-*/

}
?>