<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * CheckoutPaymentModuleNetworkMerchantsCCInput view.
 *
 * ! This view will not map anything, if the current connection is not https.
 *
 * @package PaymentModuleNetworkMerchantsCC
 * @author Egor Makarov
 */
class CheckoutPaymentModuleNetworkMerchantsCCInput
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Gets a template format for the given view.
     */
    function getTemplateFormat()
    {
            $format = array(
                'layout-file'        => "checkout-payment-module-network-merchants-cc-input-config.ini" //; $this->LayoutFile
               ,'files' => array(
                     'InputContainer'               => TEMPLATE_FILE_SIMPLE
                )
               ,'options' => array(
               )
            );
            return $format;
    }

    /**
     *  CheckoutPaymentModuleNetworkMerchantsCCInput constructor.
     */
    function CheckoutPaymentModuleNetworkMerchantsCCInput()
    {
        global $application;
        $this->HTML_LOCAL_TAGS_PREFIX = "Local_";
        #check if fatal errors exist in the block tag
        $this->NoView = false;
        if ($application->issetBlockTagFatalErrors($this->BlockTemplateName))
        {
            $this->NoView = true;
        }
        if ($application->getCurrentProtocol() == "http")
        {
            $this->NoView = "HTTPS_ERROR";
        }
    }

    /**
     *
     */
    function output()
    {
        global $application;
        $ModuleInfo = modApiFunc($this->ModuleAPIClassName, "getInfo");
        $ModuleName = $ModuleInfo['Name'];

        if ($this->NoView)
        {
            if ($this->NoView == "HTTPS_ERROR")
            {
                $msg = &$application->getInstance("MessageResources");
                return $msg->getMessage(new ActionMessage(array("HTTPS_ERROR", $ModuleName)));
            }
            return "";
        }

        loadCoreFile('html_form.php');
        $htmlForm = new HtmlForm();

        $this->templateFiller = &$application->getInstance('TemplateFiller');
        $this->template = $application->getBlockTemplate($this->BlockTemplateName);
        $this->templateFiller->setTemplate($this->template);

        $this->_Template_Contents = array(
                 $this->HTML_LOCAL_TAGS_PREFIX . 'FormMethodIdFieldName' => ""
                ,$this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodID' => ""
                ,$this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodName' => ""
                ,$this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodIsChecked' => ""
                ,$this->HTML_LOCAL_TAGS_PREFIX . 'CreditCardInfoInput' => ""
                ,$this->HTML_LOCAL_TAGS_PREFIX . 'ErrorMessage' => ""
            );

        $application->registerAttributes($this->_Template_Contents);
        $retval = $this->templateFiller->fill("InputContainer");
        return $retval;
    }

    function getTag($tag)
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-network-merchants-messages", "AdminZone");
        global $application;
        $value = null;
        switch ($tag)
        {
//            case $this->HTML_LOCAL_TAGS_PREFIX .'PaymentHTMLModuleDescription':
//                $value = $obj->getMessage('MODULE_PAYMENT_PAYPAL_PAYPAL_IPN_HTML_DESCRIPTION_CZ');
//                break;

            case $this->HTML_LOCAL_TAGS_PREFIX .'FormMethodIdFieldName':
                $value = "paymentModule[method_code]";
                break;

            case $this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodID':
                $ModuleInfo = modApiFunc($this->ModuleAPIClassName, "getInfo");
                $value = $ModuleInfo['GlobalUniquePaymentModuleID'];
                break;

            case $this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodName':
                $ModuleInfo = modApiFunc($this->ModuleAPIClassName, "getInfo");
                $value = $ModuleInfo['Name'];
                break;

            case $this->HTML_LOCAL_TAGS_PREFIX . 'PaymentMethodIsChecked':
                $ModuleInfo = modApiFunc($this->ModuleAPIClassName, "getInfo");
                $pm_uuid = $ModuleInfo['GlobalUniquePaymentModuleID'];
                $checked = modApiFunc("Checkout", "isPaymentModuleChecked", $pm_uuid);
                $value = ($checked === true ? 'checked="checked"' : "");
                break;

            case $this->HTML_LOCAL_TAGS_PREFIX . 'CreditCardInfoInput':
                $pm_uuid = call_user_func(array($this->ModuleAPIClassName, "getUid"));
                $value = getCheckoutCreditCardInfoInput($pm_uuid);
                break;

            case $this->HTML_LOCAL_TAGS_PREFIX . 'ErrorMessage':
                $value = modApiFunc($this->ModuleAPIClassName, "getErrorMessage");
                modApiFunc($this->ModuleAPIClassName, "unsetErrorMessage");
                modApiFunc($this->ModuleAPIClassName, "saveState");
                break;

        }
        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */
    var $_Template_Contents;

    var $ModuleAPIClassName = "Payment_Module_Network_Merchants_CC";
    var $BlockTemplateName = "CheckoutPaymentModuleNetworkMerchantsCCInput";
    var $LayoutFile = "checkout-payment-module-network-merchants-cc-input-config.ini";

    /**
     * A html tag prefix, added to the names of all Person Info local attributes.
     */
    var $HTML_LOCAL_TAGS_PREFIX;// = "Local_";
    /**#@-*/
}
?>