<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
 /*
  */

class NexcommercePayment {
    var $myIndustryType;
    var $myTransType;
    var $myBin;
    var $myTerminalID;

    var $myMerchantID;
    var $myGatewayURL;
    var $myGatewayURN;

    var $myCcAccountNum;
    var $myCcExp;
    var $myCcCardVerifyPresenceInd;
    var $myCcCardVerifyNum;
    var $mySwitchSoloCardStartDate;
    var $myAvsZip;
    var $myAvsAddress1;
    var $myAvsAddress2;
    var $myAvsCity;
    var $myAvsState;
    var $myAvsName;
    var $myAvsCountryCode;
    var $myOrderID;
    var $myAmount;
    var $myComments;

    var $myError;
    var $myErrorMessage;

    /***********************************************************************
     *** SET values to send to Nexcommerce                                       ***
     ***********************************************************************/
    function setCcAccountNum($CcAccountNum) {
        $this->myCcAccountNum = $CcAccountNum;
    }
    function setCcExp($CcExp) {
        $this->myCcExp = $CcExp;
    }
    function setCcCardVerifyPresenceInd($CcCardVerifyPresenceInd) {
        $this->myCcCardVerifyPresenceInd = $CcCardVerifyPresenceInd;
    }
    function setAvsZip($AvsZip) {
        $this->myAvsZip = $AvsZip;
    }
    function setAvsAddress1($AvsAddress1) {
        $this->myAvsAddress1 = $AvsAddress1;
    }
    function setAvsAddress2($AvsAddress2) {
        $this->myAvsAddress2 = $AvsAddress2;
    }
    function setAvsCity($AvsCity) {
        $this->myAvsCity = $AvsCity;
    }
    function setAvsState($AvsState) {
        $this->myAvsState = $AvsState;
    }
    function setAvsName($AvsName) {
        $this->myAvsName = $AvsName;
    }
    function setAvsCountryCode($AvsCountryCode) {
        $this->myAvsCountryCode = $AvsCountryCode;
    }
    function setOrderID($OrderID) {
        $this->myOrderID = $OrderID;
    }
    function setAmount($Amount) {
        $this->myAmount = $Amount;
    }
    function setComments($Comments) {
        $this->myComments = $Comments;
    }
    function setCcCardVerifyNum($CcCardVerifyNum) {
        $this->myCcCardVerifyNum = $CcCardVerifyNum;
    }
    function setSwitchSoloCardStartDate($SwitchSoloCardStartDate) {
        $this->mySwitchSoloCardStartDate = $SwitchSoloCardStartDate;
    }

    /***********************************************************************
     *** GET values returned by Nexcommerce                                      ***
     ***********************************************************************/

    /**
                                   :
      $parseRes = array
        (
            "faultcode" => ""
           ,"faultstring" => ""
        );
     */
    function parseFailureResponse($response)
    {
        global $application;
        $parseRes = array
        (
            "FAULTCODE" => ""
           ,"FAULTSTRING" => ""
        );

        loadCoreFile('obj_xml.php');
        $parser = new xml_doc($response);
        $parser->parse();
        foreach($parser->xml_index as $tag_key => $tag_obj)
        {
            if($tag_obj->name=="SOAP-ENV:FAULT")
            {
                foreach($tag_obj->children as $fault_tag_key => $fault_tag_obj)
                {
                    if(array_key_exists($fault_tag_obj->name, $parseRes))
                        $parseRes[$fault_tag_obj->name] = $fault_tag_obj->contents;
                }
            }
        }
        return $parseRes;
    }

    /**
                                   :
      $parseRes = array
        (
            "txRefNum" => ""
           ,"txRefIdx" => ""
           ,"procStatus" => ""
           ,"approvalStatus" => ""
           ,"respCode" => ""
        );

        txRefNum:
            Gateway transaction reference number:
            A unique value for each transaction, which is required to adjust any
            transaction in the gateway [such as Mark for Capture or void].

        txRefIdx:
            Gateway transaction index:
            Used to identify the unique components of transactions adjusted more
            than one time. Required on for void transactions.

        procStatus:
			Process Status:
			The first data set that should be checked to determine the result
            of a request. It is the only element that is returned in all response
            scenarios. It identifies whether transactions have successfully
            passed all of the Gateway edit checks.
			0   Success
			All other values constitute an error condition and will be returned
            in a SOAPFault. See appendix for definition of those error values.

        approvalStatus:
			Approval Status:
			0   Decline 1   Approved 2   Message/System Error

        respCode:
			Response Code:
			Normalized authorization response code issued by the host system
            [Salem / Tampa], which identifies an approval ( 00 ) or the reason
            for a decline or error.
			See appendix for values.

        procStatusMessage:
            Text message associated with ProcStatus value.

     */
    function parseNewOrderResponse($response)
    {
        global $application;
        $parseRes = array
        (
            "TXREFNUM" => ""
           ,"TXREFIDX" => ""
           ,"PROCSTATUS" => ""
           ,"PROCSTATUSMESSAGE" => ""
           ,"APPROVALSTATUS" => ""
           ,"RESPCODE" => ""
        );

        loadCoreFile('obj_xml.php');
        $parser = new xml_doc($response);
        $parser->parse();

        foreach($parser->xml_index as $tag_key => $tag_obj)
        {
            if($tag_obj->name=="RETURN")
            {
                foreach($tag_obj->children as $child_tag_key => $child_tag_obj)
                {
                    if(array_key_exists($child_tag_obj->name, $parseRes))
                        $parseRes[$child_tag_obj->name] = $child_tag_obj->contents;
                }
            }
        }
        return $parseRes;
    }

    function parseResponse($response)
    {
        global $application;
    	//                          :
    	//  1.
    	//  2.
    	//
    	//        .                                                          .

    	$failure_response_keyword = "Fault";
    	$new_order_response_keyword = "NewOrderResponse";
        $MR = &$application->getInstance('MessageResources','payment-module-nexcommerce-messages','AdminZone');

    	if(_ml_strpos($response, $failure_response_keyword) !== FALSE)
    	{
    		//
    		$parseRes = $this->parseFailureResponse($response);

    		//                 :
            $msg = $MR->getMessage('MODULE_PAYMENT_NEXCOMMERCE_ERROR_GATEWAY_FAILURE_RESPONSE_MSG', array($parseRes["FAULTCODE"], $parseRes["FAULTSTRING"]));
            return array
            (
                 "Error"        => NEXCOMMERCE_ERROR_GATEWAY_FAILURE_RESPONSE
                ,"ErrorMessage" => $msg
            );
    	}
    	elseif(_ml_strpos($response, $new_order_response_keyword) !== FALSE)
    	{
    		//
            $parseRes = $this->parseNewOrderResponse($response);

            //       ProcStatus    -         -
            //                          .
            if($parseRes['PROCSTATUS'] != NEXCOMMERCE_GATEWAY_RESPONSE_NEW_ORDER_PROC_STATUS_SUCCESSFUL)
            {
	            $msg = $MR->getMessage('MODULE_PAYMENT_NEXCOMMERCE_ERROR_GATEWAY_NEW_ORDER_RESPONSE_PROC_STATUS_NOT_SUCCESSFUL_MSG', array($parseRes["TXREFNUM"], $parseRes["PROCSTATUS"], $MR->getMessage('MODULE_PAYMENT_NEXCOMMERCE_NEW_ORDER_RESPONSE_PROC_STATUS_' . $parseRes["PROCSTATUS"]), $parseRes["PROCSTATUSMESSAGE"]));
	            return array
	            (
	                 "Error"        => NEXCOMMERCE_ERROR_GATEWAY_NEW_ORDER_RESPONSE_PROC_STATUS_NOT_SUCCESSFUL
	                ,"ErrorMessage" => $msg
	            );
            }

    	    //       approvalStatus    -         -
            //                          .
            if($parseRes['APPROVALSTATUS'] == NEXCOMMERCE_APPROVAL_STATUS_MESSAGE_OR_SYSTEM_ERROR)
            {
                $msg = $MR->getMessage('MODULE_PAYMENT_NEXCOMMERCE_ERROR_GATEWAY_NEW_ORDER_RESPONSE_APPROVAL_STATUS_MESSAGE_OR_SYSTEM_ERROR_MSG', array($parseRes["TXREFNUM"], $parseRes['APPROVALSTATUS']));
                return array
                (
                     "Error"        => NEXCOMMERCE_ERROR_GATEWAY_NEW_ORDER_RESPONSE_APPROVAL_STATUS_MESSAGE_OR_SYSTEM_ERROR
                    ,"ErrorMessage" => $msg
                );
            }
            //                    respCode -     "               "                           .
            //                                    .                  ,
            //  declined/error.

            return $parseRes;
    	}
    	else
    	{
    		//          ,           .                                   .
            $MR = &$application->getInstance('MessageResources','payment-module-nexcommerce-messages','AdminZone');
            $msg = $MR->getMessage('MODULE_PAYMENT_NEXCOMMERCE_MSG_ERROR_GATEWAY_RESPONSE_UNKNOWN_FORMAT');

            return array
            (
                 "Error"        => NEXCOMMERCE_ERROR_GATEWAY_RESPONSE_UNKNOWN_FORMAT
                ,"ErrorMessage" => $msg . ":'" . $response . "'."
            );
    	}
    }

    /***********************************************************************
     *** Class Constructor                                               ***
     ***********************************************************************/
    function NexcommercePayment( $MerchantID, $gatewayURL, $gatewayURN, $BIN)
    {
    	$this->myIndustryType = 'EC';
        $this->myTransType = 'AC';
        $this->myTerminalID = '001';

        $this->myMerchantID = $MerchantID;
        $this->myGatewayURL = $gatewayURL;
        $this->myGatewayURN = $gatewayURN;
        $this->myBin = $BIN;
    }

    /***********************************************************************
     *** Business Logic                                                  ***
     ***********************************************************************/
    function doPayment() {
        $DataFields = array
        (
             "NEXCOMMERCE_GATEWAY_URN" => $this->myGatewayURN
            ,"INDUSTRY_TYPE" => $this->myIndustryType
            ,"TRANS_TYPE" => $this->myTransType
            ,"BIN" => $this->myBin
            ,"MERCHANT_ID" => $this->myMerchantID
            ,"TERMINAL_ID" => $this->myTerminalID

            ,"CC_ACCOUNT_NUM" => $this->myCcAccountNum
            ,"CC_EXP" => $this->myCcExp
            ,"CC_CARD_VERIFY_PRESENCE_IND" => $this->myCcCardVerifyPresenceInd
            ,"CC_CARD_VERIFY_NUM" => $this->myCcCardVerifyNum
            ,"SWITCH_SOLO_CARD_START_DATE" => $this->mySwitchSoloCardStartDate
            ,"AVS_ZIP" => $this->myAvsZip
            ,"AVS_ADDRESS_1" => $this->myAvsAddress1
            ,"AVS_ADDRESS_2" => $this->myAvsAddress2
            ,"AVS_CITY" => $this->myAvsCity
            ,"AVS_STATE" => $this->myAvsState
            ,"AVS_NAME" => $this->myAvsName
            ,"AVS_COUNTRY_CODE" => $this->myAvsCountryCode
            ,"ORDER_ID" => $this->myOrderID
            ,"AMOUNT" => $this->myAmount
            ,"COMMENTS" => $this->myComments
        );

        $xml_content = file_get_contents(dirname(__FILE__)."/../includes/new_order_request.xml");
        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($this->myGatewayURL);
        $bnc->setPOSTstring(strtr($xml_content, $DataFields));
        $result = $bnc->RunRequest();

        $this->myError = NULL;
        // Check whether the curl_exec worked.
        if( $result !== false) {
            $Response = $result["body"];

            $parseRes = $this->parseResponse($Response);

            if( !isset($parseRes["Error"]) )
            {
            } else {
                // parse error occured.
                //                   . Return the error message and number.
                $this->myError        = $parseRes["Error"];
                $this->myErrorMessage = $parseRes["ErrorMessage"];
            }
        } else {

            $this->myError        = $bnc->errno;
            $this->myErrorMessage = $bnc->errstr;
        }

        if($this->myError !== NULL)
        {
        	return array
        	(
        	    "Error"        => $this->myError
        	   ,"ErrorMessage" => $this->myErrorMessage
        	   ,"RawGatewayResponse" => empty($Response) ? "" : $Response
        	);
        }
        else
        {
        	return array
        	(
                 "TXREFNUM" => $parseRes["TXREFNUM"]
                ,"TXREFIDX" => $parseRes["TXREFIDX"]
                ,"PROCSTATUS" => $parseRes["PROCSTATUS"]
                ,"PROCSTATUSMESSAGE" => $parseRes["PROCSTATUSMESSAGE"]
                ,"APPROVALSTATUS" => $parseRes["APPROVALSTATUS"]
                ,"RESPCODE" => $parseRes["RESPCODE"]
                ,"RawGatewayResponse" => empty($Response) ? "" : $Response
        	);
        }
    }
}
?>