<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * PaypalProExpressCheckout view.
 *
 * @package PaypalProExpressCheckout
 * @author Alexander Girin
 */
class PaypalProExpressCheckout
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Gets a template format for the given view.
     */
    function getTemplateFormat()
    {
    	$format = array(
    	    'layout-file'        => "checkout-payment-module-paypalpro-cc-express-checkout-config.ini" //; $this->LayoutFile
    	   ,'files' => array(
    	        'InputContainer'                => TEMPLATE_FILE_SIMPLE
    	       ,'OutputContainer'               => TEMPLATE_FILE_SIMPLE
    	    )
    	   ,'options' => array(
    	    )
    	);
    	return $format;
    }

    /**
     *  CheckoutPaymentModulePaypalCCOutput constructor
     */
    function PaypalProExpressCheckout()
    {
        global $application;

        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-paypalpro-messages", "AdminZone");

        #
        $this->NoView = false;
        if ($application->issetBlockTagFatalErrors($this->BlockTemplateName))
        {
            $this->NoView = true;
        }
        if (!modApiFunc("Payment_Module_PaypalPro_CC", "isActive"))
        {
            $this->NoView = true;
        }
        $sections = $application->getSectionByCurrentPagename();
        if (!in_array( "Checkout", $sections))
        {
            $this->NoView = true;
        }
    }

    /**
     *
     */
    function output()
    {
        if ($this->NoView)
        {
            return "";
        }

        global $application;
        $msg = &$application->getInstance("MessageResources");

//        $application->registerAttributes(array('PaymentHTMLModuleDescription' => $this->getTag("PaymentHTMLModuleDescription"),
//                                               'OutputField' => $this->getTag("OutputField")));

        $current_checkout_step = modApiFunc("Checkout", "getCurrentStepID");
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
//        $request->setAction("PayPalProSetExpressCheckout");
        $request->setAction("SetCurrStep");
        $request->setKey('step_id', ($current_checkout_step+1));
        $request->setKey('previous_step_id', $current_checkout_step);
        $PayPalExpressCheckoutLink = $request->getURL();

        $response = modApiFunc("Payment_Module_PaypalPro_CC", "getResponse");

        $this->ModuleSettings = modApiFunc($this->ModuleAPIClassName, "getSettings");
        $logo_src = $this->ModuleSettings["MODULE_LOGO"]? $this->ModuleSettings["MODULE_LOGO"]:"https://www.paypal.com/en_US/i/btn/btn_xpressCheckout.gif";
        $this->_Template_Contents = array(
                                          "Local_PayPalProExpressCheckoutMethod" => "<input type='image' name='PayPalProExpressCheckout' value='doPayPalProExpressCheckout' src='".$logo_src."' />"
                                         ,"Local_PayPalProExpressCheckoutLink" => $PayPalExpressCheckoutLink
                                         ,"Local_ErrorMessage" =>      (isset($response['Errors']['ErrorCode']) && $response['Errors']['ErrorCode']?
                                                                        ($response['Errors']['ErrorCode'].":"):"")
                                                                       .(isset($response['Errors']['ShortMessage']) && $response['Errors']['ShortMessage']?
                                                                        (" ".$response['Errors']['ShortMessage']):"")
                                                                       .(isset($response['Errors']['LongMessage']) && $response['Errors']['LongMessage']?
                                                                        (" ".$response['Errors']['LongMessage']):"")
                                         ,"Local_PaymentMethodName"         => ""
                                         );
        $application->registerAttributes($this->_Template_Contents);

        $this->templateFiller = &$application->getInstance('TemplateFiller');
        $this->template = $application->getBlockTemplate($this->BlockTemplateName);
        $this->templateFiller->setTemplate($this->template);

        if (modApiFunc("Payment_Module_PaypalPro_CC", "getPaymentMethod") == "ExpressCheckout")
        {
            $retval = $this->templateFiller->fill("OutputContainer");
        }
        else
        {
            $retval = $this->templateFiller->fill("InputContainer");
        }

        modApiFunc("Payment_Module_PaypalPro_CC", "clearResponseErrors");
        modApiFunc("Payment_Module_PaypalPro_CC", "saveState");
        return $retval;
    }

    function getTag($tag)
    {
        global $application;
        $value = null;
        switch ($tag)
        {
            case 'Local_PaymentMethodName':
            {
                $value = $this->ModuleSettings['EXPRESS_CHECKOUT_METHOD_NAME'];
                break;
            }

            default:
                $value = $this->_Template_Contents[$tag];
                break;
        }
        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $ModuleAPIClassName = "Payment_Module_PaypalPro_CC";
    var $BlockTemplateName = "PaypalProExpressCheckout";
    var $LayoutFile = "checkout-payment-module-paypalpro-cc-express-checkout-config.ini";
    /**#@-*/

}
?>