<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * paypalpro_uk_cc_input_az view.
 *
 * @package PaymentModulePaypalPro_UK CC
 * @author Ravil Garafutdinov
 */
class paypalpro_uk_cc_input_az extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     *
     */
    function paypalpro_uk_cc_input_az()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-paypalpro_uk-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }
    }

    /**
     *Initializes data from the POST array.
     */
    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST = $SessionPost;
        $this->POST["status"] = ($this->POST["status"] == "active") ? true : false;
    }

    /**
     * Initializes data from the database.
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Payment_Module_PaypalPro_UK_CC", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME":                  $this->POST["ModuleName"] = $value; break;
                case "EXPRESS_CHECKOUT_METHOD_NAME": $this->POST["ExpressCheckoutMethodName"] = $value; break;
                case "DIRECT_PAYMENT_METHOD_NAME":   $this->POST["DirectPaymentMethodName"] = $value; break;
                case "USERNAME" :                    $this->POST["Username"] = $value; break;
                case "VENDOR" :                      $this->POST["Vendor"] = $value; break;
                case "PASSWORD" :                    $this->POST["Password"] = $value; break;
                case "PARTNER" :                     $this->POST["Partner"] = $value; break;
                case "MERCHANT_DESCRIPTION" :        $this->POST["MerchantDescription"] = $value; break;
                case "MODULE_CART" :                 $this->POST["ModuleCart"] = $value; break;
                case "MODULE_MODE" :                 $this->POST["ModuleMode"] = $value; break;
                case "ECHECKOUT_URL_TEST" :          $this->POST["EcheckoutUrlTest"] = $value; break;
                case "ECHECKOUT_URL_LIVE" :          $this->POST["EcheckoutUrlLive"] = $value; break;
                case "GATEWAY_URL_TEST" :            $this->POST["GatewayUrlTest"] = $value; break;
                case "GATEWAY_URL_LIVE" :            $this->POST["GatewayUrlLive"] = $value; break;
                case "MODULE_LOGO" :                 $this->POST["ModuleLogo"] = $value; break;
                case "MODULE_3DS_ENABLE" :           $this->POST["Module3dsEnable"] = $value; break;
                case "MODULE_3DS_URL" :              $this->POST["Module3dsUrl"] = $value; break;
                case "MODULE_3DS_PROCESSOR_ID" :     $this->POST["Module3dsProcessorId"] = $value; break;
                case "MODULE_3DS_MERCHANT_ID" :      $this->POST["Module3dsMerchantId"] = $value; break;
                case "MODULE_3DS_TRANSACTION_PASSWORD" : $this->POST["Module3dsTransactionPassword"] = $value; break;
            }
        }
        $this->POST["status"] = modApiFunc("Payment_Module_PaypalPro_UK_CC", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );
    }

    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * Outputs errors.
     */
    function outputErrors()
    {
        global $application;
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }
        $result = "";
        $application->registerAttributes(array('ErrorIndex', 'Error'));
        $this->_error_index = 0;
        foreach ($this->ErrorsArray as $error)
        {
            $this->_error_index++;
            $this->_error = $this->MessageResources->getMessage($error);
            $result .= $this->mTmplFiller->fill("payment_module_paypalpro_uk/", "error.tpl.html", array());
        }
        return $result;
    }

    /**
     * Outputs the module status.
     */
    function outputStatus()
    {
        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_paypalpro_uk/", "status.tpl.html", array());
        return $retval;
    }

    function outputModeOptions()
    {
        $retval = "";
        $options = array(array("value" => "1", "text" => $this->MessageResources->getMessage('MODE_001')), array("value" => "2", "text" => $this->MessageResources->getMessage('MODE_002')));
        foreach ($options as $option)
        {
            $retval.= "<option value='".$option["value"]."' ".($option["value"]==$this->POST["ModuleMode"]? "selected":"").">".$option["text"]."</option>";
        }
        return $retval;
    }

    function outputCartOptions()
    {
        $retval = "";
        $options = array(array("value" => "1", "text" => $this->MessageResources->getMessage('YES_LABEL')), array("value" => "2", "text" => $this->MessageResources->getMessage('NO_LABEL')));
        foreach ($options as $option)
        {
            $retval.= "<option value='".$option["value"]."' ".($option["value"]==$this->POST["ModuleCart"]? "selected":"").">".$option["text"]."</option>";
        }
        return $retval;
    }

    function output3dsEnableOptions()
    {
        $retval = "";
        $options = array(array("value" => "0", "text" => $this->MessageResources->getMessage('DISABLE_LABEL')), array("value" => "1", "text" => $this->MessageResources->getMessage('ENABLE_LABEL')));
        foreach ($options as $option)
        {
            $retval.= "<option value='".$option["value"]."' ".($option["value"]==$this->POST["Module3dsEnable"] ? "selected":"").">".$option["text"]."</option>";
        }
        return $retval;
    }

    /**
     *
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        $request = new Request();
        $request->setView('CheckoutPaymentModuleSettings');
        $request->setAction("update_paypalpro_uk");
        $form_action = $request->getURL();

        $template_contents = array(
                                    "EditPayPalForm"        => $HtmlForm1->genForm($form_action, "POST", "EditPayPalForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"Errors"                => $this->outputErrors()
                                   ,"ModuleStatusFieldName" => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                                   ,"ModuleStatusFieldHint" => $this->Hints->getHintLink(array('MODULE_STATUS_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"ModuleStatusField"     => $this->outputStatus()

                                   ,"ModuleNameFieldName"   => $this->MessageResources->getMessage('MODULE_NAME_FIELD_NAME')
                                   ,"ModuleNameFieldHint"   => $this->Hints->getHintLink(array('MODULE_NAME_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "ModuleName", "60", prepareHTMLDisplay($this->POST["ModuleName"]))

                                   ,"Method1NameFieldName"  => $this->MessageResources->getMessage('MODULE_METHOD_NAME_FIELD_NAME_001')
                                   ,"Method1NameFieldHint"  => $this->Hints->getHintLink(array('MODULE_METHOD_NAME_FIELD_NAME_001', 'payment-module-paypalpro_uk-messages'))
                                   ,"Method1NameField"      => $HtmlForm1->genInputTextField("128", "ExpressCheckoutMethodName", "60", prepareHTMLDisplay($this->POST["ExpressCheckoutMethodName"]))

                                   ,"Method2NameFieldName"  => $this->MessageResources->getMessage('MODULE_METHOD_NAME_FIELD_NAME_002')
                                   ,"Method2NameFieldHint"  => $this->Hints->getHintLink(array('MODULE_METHOD_NAME_FIELD_NAME_002', 'payment-module-paypalpro_uk-messages'))
                                   ,"Method2NameField"      => $HtmlForm1->genInputTextField("128", "DirectPaymentMethodName", "60", prepareHTMLDisplay($this->POST["DirectPaymentMethodName"]))

                                   ,"UserNameFieldName"      => $this->MessageResources->getMessage('MODULE_USER_NAME_FIELD_NAME')
                                   ,"UserNameFieldHint"      => $this->Hints->getHintLink(array('MODULE_USER_NAME_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"UserNameField"          => $HtmlForm1->genInputTextField("128", "Username", "60", prepareHTMLDisplay($this->POST["Username"]))
                                   ,"VendorFieldName"        => $this->MessageResources->getMessage('MODULE_VENDOR_FIELD_NAME')
                                   ,"VendorFieldHint"        => $this->Hints->getHintLink(array('MODULE_VENDOR_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"VendorField"            => $HtmlForm1->genInputTextField("128", "Vendor", "60", prepareHTMLDisplay($this->POST["Vendor"]))

                                   ,"PasswordFieldName"      => $this->MessageResources->getMessage('MODULE_PASSWORD_FIELD_NAME')
                                   ,"PasswordFieldHint"      => $this->Hints->getHintLink(array('MODULE_PASSWORD_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"PasswordField"          => $HtmlForm1->genInputTextField("128", "Password", "60", prepareHTMLDisplay($this->POST["Password"]))

                                   ,"PartnerFieldName"      => $this->MessageResources->getMessage('MODULE_PARTNER_FIELD_NAME')
                                   ,"PartnerFieldHint"      => $this->Hints->getHintLink(array('MODULE_PARTNER_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"PartnerField"          => $HtmlForm1->genInputTextField("128", "Partner", "60", prepareHTMLDisplay($this->POST["Partner"]))

                                   ,"MerchantDescriptionFieldName" => $this->MessageResources->getMessage('MODULE_MERCHANT_DESCRIPTION_FIELD_NAME')
                                   ,"MerchantDescriptionFieldHint" => $this->Hints->getHintLink(array('MODULE_MERCHANT_DESCRIPTION_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"MerchantDescriptionField"     => $HtmlForm1->genInputTextField("128", "MerchantDescription", "60", prepareHTMLDisplay($this->POST["MerchantDescription"]))

                                   ,"ModuleCartFieldName"    => $this->MessageResources->getMessage('MODULE_CART_FIELD_NAME')
                                   ,"ModuleCartFieldHint"    => $this->Hints->getHintLink(array('MODULE_CART_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"ModuleCartOptions"      => $this->outputCartOptions()

                                   ,"ModuleModeFieldName"    => $this->MessageResources->getMessage('MODULE_MODE_FIELD_NAME')
                                   ,"ModuleModeFieldHint"    => $this->Hints->getHintLink(array('MODULE_MODE_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"ModuleModeOptions"      => $this->outputModeOptions()

                                   ,"EcheckoutUrlTestFieldName"  => $this->MessageResources->getMessage('MODULE_ECHECKOUT_URL_TEST_FIELD_NAME')
                                   ,"EcheckoutUrlTestFieldHint"  => $this->Hints->getHintLink(array('MODULE_ECHECKOUT_URL_TEST_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"EcheckoutUrlTestField"      => $HtmlForm1->genInputTextField("128", "EcheckoutUrlTest", "60", prepareHTMLDisplay($this->POST["EcheckoutUrlTest"]))

                                   ,"EcheckoutUrlLiveFieldName"  => $this->MessageResources->getMessage('MODULE_ECHECKOUT_URL_LIVE_FIELD_NAME')
                                   ,"EcheckoutUrlLiveFieldHint"  => $this->Hints->getHintLink(array('MODULE_ECHECKOUT_URL_LIVE_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"EcheckoutUrlLiveField"      => $HtmlForm1->genInputTextField("128", "EcheckoutUrlLive", "60", prepareHTMLDisplay($this->POST["EcheckoutUrlLive"]))

                                   ,"GatewayUrlTestFieldName"  => $this->MessageResources->getMessage('MODULE_GATEWAY_URL_TEST_FIELD_NAME')
                                   ,"GatewayUrlTestFieldHint"  => $this->Hints->getHintLink(array('MODULE_GATEWAY_URL_TEST_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"GatewayUrlTestField"      => $HtmlForm1->genInputTextField("128", "GatewayUrlTest", "60", prepareHTMLDisplay($this->POST["GatewayUrlTest"]))

                                   ,"GatewayUrlLiveFieldName"  => $this->MessageResources->getMessage('MODULE_GATEWAY_URL_LIVE_FIELD_NAME')
                                   ,"GatewayUrlLiveFieldHint"  => $this->Hints->getHintLink(array('MODULE_GATEWAY_URL_LIVE_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"GatewayUrlLiveField"      => $HtmlForm1->genInputTextField("128", "GatewayUrlLive", "60", prepareHTMLDisplay($this->POST["GatewayUrlLive"]))

                                   ,"ModuleLogoFieldName"    => $this->MessageResources->getMessage('MODULE_LOGO_FIELD_NAME')
                                   ,"ModuleLogoFieldHint"    => $this->Hints->getHintLink(array('MODULE_LOGO_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"ModuleLogoField"        => $HtmlForm1->genInputTextField("255", "ModuleLogo", "60", prepareHTMLDisplay($this->POST["ModuleLogo"]))
                                   ,"ModuleLogoSrc"          => $this->POST["ModuleLogo"]

                                   ,"Module3dsEnableFieldName"    => $this->MessageResources->getMessage('MODULE_3DS_ENABLE_FIELD_NAME')
                                   ,"Module3dsEnableFieldHint"    => $this->Hints->getHintLink(array('MODULE_3DS_ENABLE_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"Module3dsEnableOptions"      => $this->output3dsEnableOptions()

                                   ,"Module3dsUrlFieldName"  => $this->MessageResources->getMessage('MODULE_3DS_URL_FIELD_NAME')
                                   ,"Module3dsUrlFieldHint"  => $this->Hints->getHintLink(array('MODULE_3DS_URL_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"Module3dsUrlField"      => $HtmlForm1->genInputTextField("128", "Module3dsUrl", "60", prepareHTMLDisplay($this->POST["Module3dsUrl"]))

                                   ,"Module3dsProcessorIdFieldName"  => $this->MessageResources->getMessage('MODULE_3DS_PROCESSOR_ID_FIELD_NAME')
                                   ,"Module3dsProcessorIdFieldHint"  => $this->Hints->getHintLink(array('MODULE_3DS_PROCESSOR_ID_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"Module3dsProcessorIdField"      => $HtmlForm1->genInputTextField("128", "Module3dsProcessorId", "60", prepareHTMLDisplay($this->POST["Module3dsProcessorId"]))

                                   ,"Module3dsMerchantIdFieldName"  => $this->MessageResources->getMessage('MODULE_3DS_MERCHANT_ID_FIELD_NAME')
                                   ,"Module3dsMerchantIdFieldHint"  => $this->Hints->getHintLink(array('MODULE_3DS_MERCHANT_ID_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"Module3dsMerchantIdField"      => $HtmlForm1->genInputTextField("128", "Module3dsMerchantId", "60", prepareHTMLDisplay($this->POST["Module3dsMerchantId"]))

                                   ,"Module3dsTransactionPasswordFieldName"  => $this->MessageResources->getMessage('MODULE_3DS_TRANSACTION_PASSWORD_FIELD_NAME')
                                   ,"Module3dsTransactionPasswordFieldHint"  => $this->Hints->getHintLink(array('MODULE_3DS_TRANSACTION_PASSWORD_FIELD_NAME', 'payment-module-paypalpro_uk-messages'))
                                   ,"Module3dsTransactionPasswordField"      => $HtmlForm1->genInputTextField("128", "Module3dsTransactionPassword", "60", prepareHTMLDisplay($this->POST["Module3dsTransactionPassword"]))

                                   ,"PmSmAcceptedCurrencies" => $this->outputAcceptedCurrencies()

                                   ,"Alert_001"              => $this->MessageResources->getMessage('ALERT_001')
                                   ,"Alert_002"              => $this->MessageResources->getMessage('ALERT_002')
                                   ,"Alert_003"              => $this->MessageResources->getMessage('ALERT_003')
                                   ,"Alert_004"              => $this->MessageResources->getMessage('ALERT_004')
                                   ,"Alert_005"              => $this->MessageResources->getMessage('ALERT_005')
                                   ,"Alert_006"              => $this->MessageResources->getMessage('ALERT_006')
                                   ,"Alert_007"              => $this->MessageResources->getMessage('ALERT_007')
                                   ,"Alert_008"              => $this->MessageResources->getMessage('ALERT_008')
                                   ,"Alert_009"              => $this->MessageResources->getMessage('ALERT_009')
                                   ,"Alert_010"              => $this->MessageResources->getMessage('ALERT_010')
                                   ,"Alert_011"              => $this->MessageResources->getMessage('ALERT_011')
                                   ,"Alert_012"              => $this->MessageResources->getMessage('ALERT_012')
                                   );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);

        return $this->mTmplFiller->fill("payment_module_paypalpro_uk/", "list.tpl.html",array());
    }

    function getTag($tag)
    {
        global $application;
        switch ($tag)
        {
            case "Error":
                $value = $this->_error;
                break;
            case "ErrorIndex":
                $value = $this->_error_index;
                break;
            default:
                $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
                break;
        }
        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;

    /**
     * View state structure. It comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>    "LargeImage"      = "image.jpg"       //
     * <br>    "SmallImage"      = "image_small.jpg" //
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    /**#@-*/

}
?>