<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

// A const with a protocol version should be "2.22" now.
define("PROTX_PROTOCOL_VER", "2.22");

define("PROTX_LIVE_URL", "https://live.sagepay.com/gateway/service/vspform-register.vsp");
define("PROTX_TEST_URL", "https://test.sagepay.com/gateway/service/vspform-register.vsp");
define("PROTX_SIMULATOR_URL", "https://https://test.sagepay.com/simulator/VSPFormGateway.asp");

//
// Test customer's information.
//
define("PROTX_TEST_VENDOR", "testvendor");
define("PROTX_TEST_PASSWORD", "testvendor");

//
// There are get-parameters, added to the return address after the end of
// the payment, for successful and failure transactions correspondingly.
//
define("PROTX_STATUS_SUCCESS", "success");
define("PROTX_STATUS_FAILURE", "failure");

/**
 * API is the Protx Form payment module class.
 *
 * @package PaymentModuleProtxFormCC
 * @author Egor Makarov
 */
class Payment_Module_Protx_Form_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     * Payment_Module_Protx_Form_CC  constructor.
     */
    function Payment_Module_Protx_Form_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-protx-form-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
    }


    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-protx-form-messages", "AdminZone");

        list($usec, $sec) = explode(" ", microtime());

        return $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $obj->getMessage('MODULE_PAYMENT_PROTX_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-protx-form-messages", "AdminZone");

        $tables = Payment_Module_Protx_Form_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_protx_form_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];        #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);
/*
        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_DESCR", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_DESCR')).':"'.$obj->getMessage('MODULE_DESCR').'";', $columns['value']);
        $application->db->getDB_Result($query);
*/
        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_VENDOR", $columns['key']);
        $query->addInsertValue('s:7:"Your ID";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_PASSWORD", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_USE_VENDOR_EMAIL", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_VENDOR_EMAIL", $columns['key']);
        $query->addInsertValue('s:20:"you@yourbusiness.com";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(7, $columns['id']);
        $query->addInsertValue("MODULE_ALLOW_GIFT_AID", $columns['key']);
        $query->addInsertValue('s:1:"9";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(8, $columns['id']);
        $query->addInsertValue("MODULE_APPLY_AVSCV2", $columns['key']);
        $query->addInsertValue('s:1:"9";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(9, $columns['id']);
        $query->addInsertValue("MODULE_APPLY_3D_SECURE", $columns['key']);
        $query->addInsertValue('s:1:"9";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(10, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Protx_Form_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_Protx_Form_CC                    2 PersonInfoType' :
     * billingInfo
     * shippingInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-protx-form-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_PROTX_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }



    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "D46B6A5B-BC47-D085-919C-B600145A39C6";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-protx-form-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "CheckoutPaymentModuleProtxFormCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModuleProtxFormCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleProtxFormCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_protx_form_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_protx_form_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_protx_form_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_protx_form_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_protx_form_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_protx_form_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile('aal.class.php');
        $settings = $this->getSettings();

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        //$request->setKey();
        //$self_link = $request->getURL();

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());
        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, $currency_id);
        $shippingInfo = new ArrayAccessLayer($orderInfo);
        $billingInfo = new ArrayAccessLayer($orderInfo);
        $shippingInfo->setAccessMask("Shipping","attr",AAL_CUSTOM_PARAM,'value');
        $billingInfo->setAccessMask ("Billing", "attr",AAL_CUSTOM_PARAM,'value');

        $amount = number_format($this->export_PRICE_N_A(
            modApiFunc("Checkout", "getOrderPrice", "Total", $currency_id)), 2, '.', '');
        $currency = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);

        switch ($settings["MODULE_MODE"])
        {
            case "1" :
                // Test(Dummy)
                $vendorId = PROTX_TEST_VENDOR;
                $vendorPassword = PROTX_TEST_PASSWORD;
                $protxURL = PROTX_TEST_URL;
                $request->setKey("testmode", "yes");
                // HACK. Is used, for the server not to return constantly an
                // error "ununique transaction id". Perhaps md5 should be transferred
                // from a large random number.
                $vendorTxCode = md5($orderId);
                break;
            case "2" :
                // Test(VSP Simulator)
                $vendorId = $settings["MODULE_VENDOR"];
                $vendorPassword = $settings["MODULE_PASSWORD"];
                $protxURL = PROTX_SIMULATOR_URL;
                $vendorTxCode = $orderId;
                break;
            case "3" :
                // Test (Test Server)
                $vendorId = $settings["MODULE_VENDOR"];
                $vendorPassword = $settings["MODULE_PASSWORD"];
                $protxURL = PROTX_TEST_URL;
                $vendorTxCode = $orderId;
                break;
            case "4" :
                // Production
                $vendorId = $settings["MODULE_VENDOR"];
                $vendorPassword = $settings["MODULE_PASSWORD"];
                $protxURL = PROTX_LIVE_URL;
                $vendorTxCode = $orderId;
                break;
        }

        $self_link = $request->getURL("", true);
        //
        // create an encoded string with the order parameters
        //

        //
        // Common info
        //
        $data_to_crypt  = $this->makeParamEntry("VendorTxCode", $vendorTxCode);
        $data_to_crypt .= $this->makeParamEntry("Amount",       $amount);
        $data_to_crypt .= $this->makeParamEntry("Currency",     $currency);
        $data_to_crypt .= $this->makeParamEntry("Description",  "Goods"); //  :
        $data_to_crypt .= $this->makeParamEntry("SuccessURL",   $self_link . "&status=" . PROTX_STATUS_SUCCESS);
        $data_to_crypt .= $this->makeParamEntry("FailureURL",   $self_link . "&status=" . PROTX_STATUS_FAILURE);
        $data_to_crypt .= $this->makeParamEntry("CustomerName", $billingInfo->getByMask("Firstname")." ".$billingInfo->getByMask("Lastname"));
        $data_to_crypt .= $this->makeParamEntry("CustomerEMail",$billingInfo->getByMask("Email"));
        $data_to_crypt .= $this->makeParamEntry("VendorEMail",  $settings["MODULE_VENDOR_EMAIL"]);

        //
        //  - a parameter is not transferred from custom email-message ("eMailMessage[7500]")
        //

       	//
       	// Billing info
       	//
        if ($billingInfo->isDefinedByMask("Postcode"))
        {
        	// the address can be specified only with the zip-code

        	$billing_address = "";
            $billing_address_list = array(  $billingInfo->getByMask("Country"),
                                            $billingInfo->getByMask("State"),
                                            $billingInfo->getByMask("City"),
                                            $billingInfo->getByMask("Streetline1"),
                                            $billingInfo->getByMask("Streetline2")
                                          );

            // concatenate a string, delete backup commas
            // and commas from both sides of the string.
            $billing_address = trim(preg_replace('/(, )+/', ', ', implode(', ', $billing_address_list)), ", ");

        	if (_ml_strlen($billing_address) > 200)
        	{
        	    $billing_address = _ml_substr($billing_address, 0, 200);
        	}

        	if (!empty($billing_address))
        	{
    	      	$data_to_crypt .= $this->makeParamEntry("BillingAddress", $billing_address);
              	$data_to_crypt .= $this->makeParamEntry("BillingPostCode", $billingInfo->getByMask("Postcode"));
        	}
        }

        //
        // Shipping info
        //
        if ($shippingInfo->isDefinedByMask("Postcode"))
        {
            $delivery_address = "";

            $delivery_address_list = array( $shippingInfo->getByMask("Country"),
                                            $shippingInfo->getByMask("State"),
                                            $shippingInfo->getByMask("City"),
                                            $shippingInfo->getByMask("Streetline1"),
                                            $shippingInfo->getByMask("Streetline2")
                                          );

            // concatenate a string, delete backup commas
            // and commas from both sides of the string.
            $delivery_address = trim(preg_replace('/(, )+/', ', ', implode(', ', $delivery_address_list)), ", ");

            if (_ml_strlen($delivery_address) > 200)
            {
                $delivery_address = _ml_substr($delivery_address, 0, 200);
            }

            if ($delivery_address)
            {
                $data_to_crypt .= $this->makeParamEntry("DeliveryAddress", $delivery_address);
                $data_to_crypt .= $this->makeParamEntry("DeliveryPostCode", $shippingInfo->getByMask("Postcode"));
            }
        }

        //
        // Customer phone
        //
        if ($billingInfo->isDefinedByMask("Phone"))
        {
            $data_to_crypt .= $this->makeParamEntry("ContactNumber", $billingInfo->getByMask("Phone"));
        }

        //
        // Basket
        //
        $prod_num = sizeof($orderInfo["Products"]);
        $basket_data = "{$prod_num}:";
        for ($i = 0; $i < $prod_num; $i++)
        {
            // add only the product name and its quantity.
            $basket_data .= prepareHTMLDisplay($orderInfo["Products"][$i]["name"]) . ":" .
                $orderInfo["Products"][$i]["qty"] . ":---:---:---:---:";
        }
        $len = _ml_strlen($basket_data);
        $basket_data = _ml_substr($basket_data, 0, $len - 1); //                             .
        $data_to_crypt .= $this->makeParamEntry("Basket", $basket_data);

        //
        // Account parameters
        //
        $data_to_crypt .= $settings["MODULE_ALLOW_GIFT_AID"] != "9" ?
            "AllowGiftAid=" . $settings["MODULE_ALLOW_GIFT_AID"] . "&" : "";
        $data_to_crypt .= $settings["MODULE_APPLY_AVSCV2"] != "9" ?
            "ApplyAVSCV2=" . $settings["MODULE_APPLY_AVSCV2"] . "&" : "";
        $data_to_crypt .= $settings["MODULE_APPLY_3D_SECURE"] != "9" ?
            "Apply3DSecure=" . $settings["MODULE_APPLY_3D_SECURE"] . "&" : "";

        $data_to_crypt = _byte_substr($data_to_crypt, 0, _byte_strlen($data_to_crypt) - 1); //                           "&"

        // encode the string with the order parameters
        $xoredData = $this->simpleXor($data_to_crypt, $vendorPassword);
        $crypted_order_data = $this->base64Encode($xoredData);


        $confirmationData = array
            (
                "FormAction" => $protxURL
                ,"FormMethod" => "POST"
                ,"DataFields" => array
                (
                    "VPSProtocol"        => PROTX_PROTOCOL_VER
                    ,"TxType"            => "PAYMENT"
                    ,"Vendor"            => $vendorId
                    ,"Crypt"             => $crypted_order_data
                )
            );

        return $confirmationData;
    }


    /**
     * Converts the pair "NAME-VALUE" to a string of the type "NAME=VALUE&" ,
     * if VALUE is not an empty string, returns an empty string otherwise.
     *
     * @param string $paramName
     * @param string $paramValue
     * @return string
     */
    function makeParamEntry($paramName, $paramValue)
    {
        $result = "";
        if ($paramValue)
        {
        	$result = $paramName . "=" . $paramValue . "&";
        }
        return $result;
    }


    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id /*, &$DBPaymentStatus, &$bStop, &$bPaymentFinished, &$EventType */)
    {
        global $application;
        $msg = &$application->getInstance('MessageResources',"payment-module-protx-form-messages", "AdminZone");
        $settings = $this->getSettings();

        //
        // Check if the encoded parameter crypt exists and if it does, decode it to the token array.
        //
        $paramsPresent = false;
        if (array_key_exists("_GET", $data) == true
            && array_key_exists("crypt", $data["_GET"]) == true
            && !empty($data["_GET"]["crypt"]))
        {
            $base64Data = $data["_GET"]["crypt"];
        	$xoredData = $this->base64Decode($base64Data);
        	$password = array_key_exists("testmode", $data["_GET"]) ? PROTX_TEST_PASSWORD : $settings["MODULE_PASSWORD"];
        	$notifyDataString = $this->simpleXor($xoredData, $password);
        	$notifyData = $this->getToken($notifyDataString);
            $paramsPresent = true;
        }

        //
        // add an incoming order message to history
        //
        $incommingHistoryMessage = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
            $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_INCOMMING') . "\n";

        if ($paramsPresent)
        {
        	$incommingHistoryMessage .= $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_EXTRA') . "\n" .
        	   print_r($notifyData, true);
        }
        modApiFunc("Checkout", "addOrderHistory", $order_id, $incommingHistoryMessage);

        //
        // check if required fields exist
        //
        $paramsOK = false;
        if ($paramsPresent === true)
        {
            $paramsOK = array_key_exists("Status", $notifyData) == true;
        }

        //
        // Add a message to history and update the order status.
        //
        if (!$paramsPresent)
        {
            $EventType = "ConfirmationFailure";
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 1,
                $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_NO_PARAMETERS_FAILURE') . "\n" .
                print_r($data["_GET"], true));
        }
        else if (!$paramsOK)
        {
            $EventType = "ConfirmationFailure";
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 1,
                $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_INVALID'));
        }
        else
        {
            $status = $notifyData["Status"];

            if ($status == "OK" || $status == "NOTAUTHED" || $status == "ABORTED" || $status == "REJECTED")
            {
                modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID",
                    $order_id, $notifyData["VPSTxId"]);
            }

            switch ($status)
            {
                case "OK" :
                    $EventType = "ConfirmationSuccess";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_OK'));
                    break;

                case "NOTAUTHED" :
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_NOTAUTHED'));
                    break;

                case "MALFORMED" :
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_MALFORMED'));
                    break;

                case "INVALID" :
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_INVALID'));
                    break;

                case "ABORT" :
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_ABORT'));
                    break;

                case "ERROR" :
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_ERROR'));
                    break;

                case "REJECTED" :
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_REJECTED'));
                    break;

                default :
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_INVALID_STATUS_FAILURE') .
                        $status);
                    break;
            }
        }

        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Protx_Form_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_protx_form_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_protx_form_setting_id'
               ,'key'               => $settings.'.pm_protx_form_setting_key'
               ,'value'             => $settings.'.pm_protx_form_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }


    // ---------------------------------------------------------------
    // Begin Protx stuff
    // ---------------------------------------------------------------

    // Base 64 Encoding function
    // PHP does it natively but just for consistency and ease of maintenance,
    // let's declare our own function
    function base64Encode($plain)
    {
        $output = "";
        $output = base64_encode($plain);
        return $output;
    }

    function base64Decode($scrambled)
    {
        $output = "";
        $scrambled = str_replace(" ","+",$scrambled);
        $output = base64_decode($scrambled);
        return $output;
    }

    //
    // In the next protocol versions will be used
    // an usual encoding algorithm.
    //
    function simpleXor($InString, $Key)
    {
        // Initialise key array
        $KeyList = array();
        // Initialise out variable
        $output = "";
        // Convert $Key into array of ASCII values
        for($i = 0; $i < _byte_strlen($Key); $i++)
        {
            $KeyList[$i] = _byte_ord(_byte_substr($Key, $i, 1));
        }
        // Step through string a character at a time
        for($i = 0; $i < _byte_strlen($InString); $i++)
        {
            // Get ASCII code from string, get ASCII code from key (loop through with MOD), XOR the two, get the character from the result
            // % is MOD (modulus), ^ is XOR
            $output.= _byte_chr(_byte_ord(_byte_substr($InString, $i, 1)) ^ ($KeyList[$i % _byte_strlen($Key)]));
        }
        // Return the result
        return $output;
    }

    // The getToken function.                                                                                         **
    // NOTE:
    //     A function of convenience that extracts the value from the
    //     "name=value&name2=value2..." VSP reply string.
    //     Works even if one of the values is a URL containing the & or = signs.                                      */
    function getToken($thisString)
    {
        // List the possible tokens
        $Tokens = array
            (
            "Status",
            "StatusDetail",
            "VendorTxCode",
            "VPSTxId",
            "TxAuthNo",
            "Amount",
            "AVSCV2",
            "AddressResult",
            "PostCodeResult",
            "CV2Result",
            "GiftAid",
            "3DSecureStatus",
            "CAVV"
            );
        // Initialise arrays
        $output = array();
        $resultArray = array();
        // Get the next token in the sequence
        for ($i = count($Tokens)-1; $i >= 0 ; $i--)
        {
            // Find the position in the string
            $start = _ml_strpos($thisString, $Tokens[$i]);
            // If it's present
            if ($start !== false)
            {
                // Record position and token name
                $resultArray[$i]->start = $start;
                $resultArray[$i]->token = $Tokens[$i];
            }
        }
        // Sort in order of position
        sort($resultArray);
        // Go through the result array, getting the token values
        for ($i = 0; $i<count($resultArray); $i++)
        {
            // Get the start point of the value
            $valueStart = $resultArray[$i]->start + _ml_strlen($resultArray[$i]->token) + 1;
            // Get the length of the value
            if ($i==(count($resultArray)-1))
            {
                $output[$resultArray[$i]->token] = _ml_substr($thisString, $valueStart);
            }
            else
            {
                $valueLength = $resultArray[$i+1]->start - $resultArray[$i]->start - _ml_strlen($resultArray[$i]->token) - 2;
                $output[$resultArray[$i]->token] = _ml_substr($thisString, $valueStart, $valueLength);
            }
        }
        // Return the ouput array
        return $output;
    }

    // ----------------------------------------
    // End Protx Stuff
    // ----------------------------------------


    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>