<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for update PSiGate settings.
 *
 * @package PaymentModulePSiGateCC
 * @access  public
 * @author Alexander Belyakov
 */
class update_psigate extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_psigate()
    {
    }


    function saveDataToDB($SessionPost)
    {
        if (!defined('DEMO_MODE'))
        {
            modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_PSiGate_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);
        }

        $Settings = array
            (
                "MODULE_NAME"  => $SessionPost["ModuleName"]
//              ,"MODULE_DESCR" => $SessionPost["ModuleDescr"]
                ,"MODULE_URL" => $SessionPost["ModuleURL"]
                ,"MODULE_STORE_KEY" => $SessionPost["ModuleStoreKey"]
                ,"MODULE_MODE" => $SessionPost["ModuleMode"]
                ,"MODULE_CART" => $SessionPost["ModuleCart"]
                ,"MODULE_BILLING_INFO" => $SessionPost["ModuleBillingInfo"]
                ,"MODULE_SHIPPING_INFO" => $SessionPost["ModuleShippingInfo"]
//              ,"MODULE_ORDER_STATUS_ID" => $SessionPost["ModuleOrderStatusId"]
            );

        modApiFunc("Payment_Module_PSiGate_CC", "updateSettings", $Settings);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        $ocntr = modApiFunc("Location","getCountryCode",modApiFunc("Configuration","getValue",SYSCONFIG_STORE_OWNER_COUNTRY));

        $main_currency_id = modApiFunc("Localization", "getMainStoreCurrency");
        $local_currency_code = modApiFunc("Localization", "getCurrencyCodeById", $main_currency_id);

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                //$nErrors = 0;
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo, CreditCardInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "shippingInfo", "creditCardInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if (empty($SessionPost["ModuleName"]) == true || trim($SessionPost["ModuleName"]) == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_NAME";
                }
                if (empty($SessionPost["ModuleURL"]) == true || trim($SessionPost["ModuleURL"]) == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_URL";
                }
                else
                {
                    $urlString = $SessionPost["ModuleURL"];
                    loadCoreFile("URI.class.php");
                    $url = new URI($urlString);
                    if ($url == NULL)
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = 'MODULE_ERROR_MALFORMED_URL';
                    }
                    else if ($url->getPart("scheme") == NULL ||
                        $url->getPart("host") == NULL ||
                        $url->getPart("user") != NULL ||
                        $url->getPart("pass") != NULL ||
                        $url->getPart("query") != NULL )
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = 'MODULE_ERROR_MALFORMED_URL';
                    }
                }

                if (empty($SessionPost["ModuleStoreKey"]) == true || trim($SessionPost["ModuleStoreKey"]) == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_INVALID_STORE_KEY";
                }
                if(!($ocntr=="CA" || $ocntr=="US"))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][]="MODULE_ERROR_WRONG_COUNTRY";
                }
                if(!($local_currency_code=="CAD" || $local_currency_code=="USD"))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][]="MODULE_ERROR_WRONG_CURRENCY";
                }

                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if ($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>