<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for update Worldpay settings.
 *
 * @package PaymentModuleWorldpayCC
 * @access  public
 * @author Egor Makarov
 */
class update_worldpay extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * update_worldpay constructor.
     */
    function update_worldpay()
    {
    }


    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_Worldpay_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array
            (
                "MODULE_NAME"  => $SessionPost["ModuleName"]
                ,"MODULE_MODE" => $SessionPost["ModuleMode"]
                ,"MODULE_ID"   => $SessionPost["ModuleId"]
                ,"MODULE_CALLBACK_FILE" => trim($SessionPost["ModuleCallbackFile"])
            );

        if (array_key_exists("ModuleUsePassword", $SessionPost))
        {
            $Settings["MODULE_USE_PASSWORD"] = "1";
            $Settings["MODULE_PASSWORD"] = $SessionPost["ModulePassword"];
        }
        else
        {
            $Settings["MODULE_USE_PASSWORD"] = "0";
            $Settings["MODULE_PASSWORD"] = "";
        }

        modApiFunc("Payment_Module_Worldpay_CC", "updateSettings", $Settings);
    }

    function isPageFilenameValid($filename)
    {
        return preg_match("/^[-_\+\.a-zA-Z]+\.html$/", $filename);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo, CreditCardInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if (array_key_exists("ModuleId", $SessionPost) != true || trim($SessionPost["ModuleId"]) == "")
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_ID";
                }
                if (array_key_exists("ModuleName", $SessionPost) != true || trim($SessionPost["ModuleName"]) == "")
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_NAME";
                }
                if (array_key_exists("ModuleUsePassword", $SessionPost) && $SessionPost["ModulePassword"] == "")
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_EMPTY_PASSWORD";
                }
                if (array_key_exists("ModuleCallbackFile", $SessionPost) != true || trim($SessionPost["ModuleCallbackFile"] == ""))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_EMPTY_FILENAME";
                }
                else if ($this->isPageFilenameValid(trim($SessionPost["ModuleCallbackFile"])) != true)
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_INVALID_FILENAME";
                }

                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>