<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

define("WORLDPAY_URL", 'https://select.worldpay.com/wcc/purchase');

/**
 *
 * @package PaymentModuleWorldpayCC
 * @author Egor Makarov
 */
class Payment_Module_Worldpay_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     *  Payment_Module_Worldpay_CC constructor.
     */
    function Payment_Module_Worldpay_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-worldpay-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_WORLDPAY_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
    }


    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-worldpay-messages", "AdminZone");

        list($usec, $sec) = explode(" ", microtime());

        return $obj->getMessage('MODULE_PAYMENT_WORLDPAY_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $obj->getMessage('MODULE_PAYMENT_WORLDPAY_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-worldpay-messages", "AdminZone");

        $tables = Payment_Module_Worldpay_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_worldpay_settings';            // the name of the filled table
        $columns = $tables[$table]['columns'];        // the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);
/*
        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_DESCR", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_DESCR')).':"'.$obj->getMessage('MODULE_DESCR').'";', $columns['value']);
        $application->db->getDB_Result($query);
*/
        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_ID", $columns['key']);
        $query->addInsertValue('s:7:"your id";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_USE_PASSWORD", $columns['key']);
        $query->addInsertValue('s:1:"0";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_PASSWORD", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(7, $columns['id']);
        $query->addInsertValue("MODULE_CALLBACK_FILE", $columns['key']);
        $query->addInsertValue('s:11:"result.html";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Worldpay_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        PayPalPro                    1 PersonInfoType:
     * billingInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-worldpay-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_WORLDPAY_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }


    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "17C89471-CB6D-47A0-C542-22DCF590AC46";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-worldpay-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "Description" => $obj->getMessage("MODULE_DESCR"),
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "CheckoutPaymentModuleWorldpayCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModuleWorldpayCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleWorldpayCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_worldpay_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_worldpay_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }


    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_worldpay_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_worldpay_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_worldpay_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_worldpay_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile('aal.class.php');
        $Settings = $this->getSettings();

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $selfLink = $request->getURL("", true);

         // the scheme can't be transferred, it is adjusted in the interface of the worldpay account
//        $selfLink = str_replace(array("http://", "https://"), "", $selfLink);
        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());
        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, $currency_id);
        $billingInfo = new ArrayAccessLayer($orderInfo);//["Billing"]["attr"];
        $billingInfo->setAccessMask("Billing","attr",AAL_CUSTOM_PARAM,'value');

        $amount = number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid()))), 2, ".", null);
        $currencyCode = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);



        switch($Settings["MODULE_MODE"])
        {
            case "1" :
                $testMode = 100;
                break;
            case "2" :
                $testMode = 101;
                break;
            case "3" :
                $testMode = 0;
                break;
        }

        $confirmationData = array
            (
                "FormAction" => WORLDPAY_URL
                ,"FormMethod" => "POST"
                ,"DataFields" => array
                (
                    "instId"    => $Settings["MODULE_ID"]
                    ,"cartId"   => $orderId
                    ,"testMode" => $testMode
                    ,"amount"   => $amount
                    ,"currency" => $currencyCode
                    ,"MC_callback" => $selfLink
                    //
                    // Billing info
                    //
                    ,"name"     => $billingInfo->getByMask("Firstname"). " " . $billingInfo->getByMask("Lastname")
                    ,"address"  => $billingInfo->getByMask("Streetline1"). " " . $billingInfo->getByMask("Streetline2")
                    ,"postcode" => $billingInfo->getByMask("Postcode")
                    ,"country"  => modApiFunc("Location", "getCountryCodeByCountryName", $billingInfo->getByMask("Country"))
                    ,"tel"      => $billingInfo->getByMask("Phone")
                    ,"email"    => $billingInfo->getByMask("Email")
                    ,"resultFile" => $Settings["MODULE_CALLBACK_FILE"]
                )
            );

        if ($Settings["MODULE_USE_PASSWORD"] == "1")
        {
            $signatureText = $Settings["MODULE_PASSWORD"] . ":"	. $amount . ":" .
                $currencyCode . ":" . $orderId;
            $md5Signature = md5($signatureText);

            $confirmationData["DataFields"]["signatureFields"] = "amount:currency:cartId";
            $confirmationData["DataFields"]["signature"] = $md5Signature;
        }


        return $confirmationData;
    }


     //
     // The method will be invoked 2 times:
     // 1. By the server WorldPay notification callback' .
     // 2. By returning the customer from the payment gateway to ASC.
     //
     // 1. A payment status will be changed for Success or Failure
     //      (if all required POST-data exist).
     //    After that wll be outputted a template with a confirmation and
     //      a reference to ASC with the same action=UpdatePaymentStatus.
     // 2. A payment status will be checked, if it is Success or Failure (i.e.
     //      if the payment notification has already been processed), the method
     //      returns into view the appropriate values EventType and statusChanged.
     //
    /**
     *                                               ,                              .
     *      &$bStop                                  .         true                         ,
     *           Checkout                                  [                   ].
     */
    function processData($data, $order_id /*, &$DBPaymentStatus, &$bStop, &$bPaymentFinished, &$EventType */)
    {
        global $application;
        $msg = &$application->getInstance('MessageResources',"payment-module-worldpay-messages", "AdminZone");

        $isReturn = array_key_exists("worldpay_return", $data["_GET"]);
        if ($isReturn)
        {
            //
            // the order info has been already processed, that is why return
            // the appropriate values EventType and statusChanged
            //
            $orderInfo = modApiFunc("Checkout", "getOrderInfo", $order_id, modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $order_id, $this->getUid()));

            $currentPaymentStatus = $orderInfo["PaymentStatusId"];
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id,
                $currentPaymentStatus);
            $EventType = $currentPaymentStatus == 2 ? "ConfirmationSuccess" : "ConfirmationFailure";
            return array("EventType" => $EventType, "statusChanged" => $result);
        }

        $postData = $data["_POST"];

        $incommingHistoryMessage = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msg->getMessage('MODULE_PAYMENT_WORLDPAY_LOG_EVENT_DESCRIPTION') .
            $msg->getMessage('MODULE_PAYMENT_WORLDPAY_LOG_MESSAGE_INCOMMING') . "\n" .
            $msg->getMessage('MODULE_PAYMENT_WORLDPAY_LOG_EXTRA') . "\n" .
            print_r($postData, true);
        modApiFunc("Checkout", "addOrderHistory", $order_id, $incommingHistoryMessage);

        if (isset($postData["transId"]))
        {
            modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $postData["transId"]);
        }

        $parametersPresent = array_key_exists("transStatus", $postData);

        if ($parametersPresent == true)
        {
            switch ($postData["transStatus"])
            {
                case "Y":
                    $paymentStatus = 2;
                    $EventType = "ConfirmationSuccess";
                    $msgId = 'MODULE_PAYMENT_WORLDPAY_LOG_MESSAGE_ACCEPTED';
                    break;

                case "C":
                    $paymentStatus = 3;
                    $EventType = "ConfirmationFailure";
                    $msgId = 'MODULE_PAYMENT_WORLDPAY_LOG_MESSAGE_CANCELLED';
                    break;

                default:
                    $paymentStatus = 3;
                    $EventType = "ConfirmationFailure";
                    $msgId = 'MODULE_PAYMENT_WORLDPAY_LOG_MESSAGE_INVALID_RESPONSE';
                    break;
            }
        }
        else
        {
            $paymentStatus = 3;
            $msgId = 'MODULE_PAYMENT_WORLDPAY_LOG_MESSAGE_INVALID_RESPONSE';
        }

        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, $paymentStatus,
            $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msg->getMessage('MODULE_PAYMENT_WORLDPAY_LOG_EVENT_DESCRIPTION') .
            $msg->getMessage($msgId));


//        $request = new Request();
//        $request->setView(CURRENT_REQUEST_URL);
//        $request->setAction("UpdatePaymentStatus");
//        $request->setKey("asc_oid", $order_id);
//        $request->setKey("worldpay_return", null);
//        $selfLink = $request->getURL();

//        $confPage = $this->_getConfirmationPageContents($paymentStatus, $selfLink);
//        echo $confPage;

//        exit();
        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Worldpay_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_worldpay_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_worldpay_setting_id'
               ,'key'               => $settings.'.pm_worldpay_setting_key'
               ,'value'             => $settings.'.pm_worldpay_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    function _getConfirmationPageContents($paymentStatus, $selfLink)
    {
        global $application;
        $msg = &$application->getInstance('MessageResources',"payment-module-worldpay-messages", "AdminZone");

        $this->templateFiller = &$application->getInstance('TemplateFiller');
        $this->template = $application->getBlockTemplate('CheckoutPaymentModuleWorldpayCCConfirm');
        $this->templateFiller->setTemplate($this->template);

        $template_name = $paymentStatus == 2 ? "ConfirmPageSuccess" : "ConfirmPageFailure";
        $retval = $this->templateFiller->fill($template_name);

        $retval = str_replace(
            "___WorldpayReturnToAscLink",
            $selfLink,
            $retval);

        $retval = str_replace(
            "___WorldpayBanner",
            "<WPDISPLAY ITEM=banner>",
            $retval);

        return $retval;
    }


    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates whether the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>