<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Shipping Module "Canada Post"
 *
 * @package ShippingModuleCPC
 * @author Egor V. Derevyankin
 */

class Shipping_Module_CPC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * ShippingModuleCPC  constructor.
     */
    function Shipping_Module_CPC()
    {
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )

            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }
	function getUID()
	{
		return "951A1AB6-A999-49F4-A041-529FA7A05629";
	}

    /**
     * @return Info about this shipping module
     */
    function getInfo()
    {

        global $application;
        $obj = &$application->getInstance('MessageResources',"shipping-module-cpc-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniqueShippingModuleID" => $this->getUID(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>", //NOT for active/inactive.
                     "PreferencesAZViewClassName" => "cpc_input_az",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Check requirments.
     *
     * @return array with the failed requirments
     */
    function checkRequirments()
    {
        $return=array();

        // 18
        //

        //check origin country
//        $ocntr = modApiFunc("Location","getCountryCode",modApiFunc("Configuration","getValue",SYSCONFIG_STORE_OWNER_COUNTRY));
//        if($ocntr!="CA")
//            $return[]="OCNTR";

        //check local currency
//        $main_currency_id = modApiFunc("Localization", "getMainStoreCurrency");
//        $local_currency_code = modApiFunc("Localization", "getCurrencyCodeById", $main_currency_id);
//        if($local_currency_code!="CAD")
//            $return[]="CURRENCY";

        return $return;
    }

    /**
     * Module installator.
     */
    function install()
    {
        _use(dirname(__FILE__).'/includes/install.inc');

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       ShippingModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Shipping_Module_CPC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      ShippingModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        CPC                         PersonInfoType:
     * shippingInfo
     *
     * @param string $person_info_type_tag - tag      person info type' ,
     *                      (turn off)   CheckoutFormEditor' .
     *
     * @return mixed - NULL,                       - "          ",       -
     *                                     ,            ,
     *        (                                   ).
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"shipping-module-cpc-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_SHIPPING_CPC_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }


    /**
     * @return true if module is active or false if is not
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules", "shipping");
        return array_key_exists($this->getUid(), $active_modules);
    }

    /**
     * Uninstall the module.
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Shipping_Module_CPC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * @param $method_id ID of shipping method of this module
     * @return true if ID is valid or false if it is not
     */
    function isValidShippingMethodId($method_id)
    {
        $check_result = execQuery('SELECT_SM_CPC_METHODS',array('ApiClassName' => __CLASS__, 'method_id' => $method_id));

        if(isset($check_result[0]['id']))
            return true;
        else
            return false;
    }

    /**
     * @param $method_id ID of shipping method of this module
     * @param $and_calc true if it is necessary to calculate the shipping cost
     *        or false if it is not
     * @return array with the shipping method info (id,method_name,method_code,
     * destination,available,cost)
     */
    function getShippingMethodInfo($method_id,$and_calc=false)
    {
        $select_result = execQuery('SELECT_SM_CPC_METHODS_EXT',array('ApiClassName' => __CLASS__, 'method_id' => $method_id));

        $method=$select_result[0];
        $method["cost"]=PRICE_N_A;

        if($and_calc!=false)
        {
            //$ShippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
            //$pak_weight=modApiFunc("Checkout", "getOrderWeight", "netto");
            $ShippingInfo = modApiFunc("Shipping_Cost_Calculator","getShippingInfo");
            $pak_weight = modApiFunc("Shipping_Cost_Calculator","getPackWeight");
            $rate=$this->getRateFromCache($ShippingInfo,$pak_weight,$method_id);
            if($rate!=false)
                $method["cost"]=$rate;
        };

        return $method;
    }

    /**
     * @return structure of the tables of this module
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'sm_cpc_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.sm_cpc_setting_id'
               ,'key'               => $settings.'.sm_cpc_setting_key'
               ,'value'             => $settings.'.sm_cpc_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        $methods = 'sm_cpc_methods';
        $tables[$methods] = array();
        $tables[$methods]['columns'] = array
            (
                'id'                => $methods.'.sm_cpc_method_id'
               ,'method_code'       => $methods.'.sm_cpc_method_code'
               ,'method_name'       => $methods.'.sm_cpc_method_name'
               ,'destination'       => $methods.'.sm_cpc_method_destination'
               ,'available'         => $methods.'.sm_cpc_method_available'
            );
        $tables[$methods]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'method_code'       => DBQUERY_FIELD_TYPE_CHAR20
               ,'method_name'       => DBQUERY_FIELD_TYPE_CHAR255
               ,'destination'       => DBQUERY_FIELD_TYPE_CHAR1 .' default \'L\''
               ,'available'         => DBQUERY_FIELD_TYPE_CHAR1 .' default \'N\''
            );
        $tables[$methods]['primary'] = array
            (
                'id'
            );

        $rates_cache = 'sm_cpc_rates_cache';
        $tables[$rates_cache] = array();
        $tables[$rates_cache]['columns'] = array
            (
                'id'                => $rates_cache.'.sm_cpc_crate_id'
               ,'hash'              => $rates_cache.'.sm_cpc_crate_hash'
               ,'method_id'         => $rates_cache.'.sm_cpc_crate_method_id'
               ,'rate'              => $rates_cache.'.sm_cpc_crate_rate'
               ,'expire'            => $rates_cache.'.sm_cpc_crate_expire'
            );
        $tables[$rates_cache]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'hash'              => DBQUERY_FIELD_TYPE_CHAR50
               ,'method_id'         => DBQUERY_FIELD_TYPE_INT
               ,'rate'              => DBQUERY_FIELD_TYPE_DECIMAL20_5
               ,'expire'            => DBQUERY_FIELD_TYPE_INT
            );
        $tables[$rates_cache]['primary'] = array
            (
                'id'
            );


        global $application;
        return $application->addTablePrefix($tables);
    }

    /**
     *
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('sm_cpc_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * @return array of the settings of this module
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'sm_cpc_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets settings for this module.
     *
     * @param $Settings array of the all settings of this module
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['sm_cpc_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('sm_cpc_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Updates settings for this module.
     *
     * @param $Settings array of the updated settings of this module
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['sm_cpc_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('sm_cpc_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * @param $type type of the requested methods (ALL|AVAILABLE|NOT_AVAILABLE)
     * @param $and_calc true if it is necessary to calculate the shipping cost
     *        or false if it is not
     * @return array of the shipping methods arrays, every will be as
     *         (id,method_name,method_code,destination,available,cost)
     */
    function getShippingMethods($type="ALL",$and_calc=false)
    {
        $available_condition=($type=="AVAILABLE"?"'Y'":($type=="NOT_AVAILABLE"?"'N'":""));
        $methods = execQuery('SELECT_SM_CPC_METHODS_EXT_2',array('ApiClassName' => __CLASS__, 'available_condition' => $available_condition));

        if($and_calc!=false and !empty($methods))
        {
            /*
            if($this->is_debug==true)
            {
                $ShippingInfo = modApiFunc("Shipping_Tester","getShippingInfo");
                $pak_weight=modApiFunc("Shipping_Tester","getPackWeight");
            }
            else
            {
                $ShippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
                $pak_weight=modApiFunc("Checkout", "getOrderWeight", "netto");
            }
            */
            $ShippingInfo = modApiFunc("Shipping_Cost_Calculator","getShippingInfo");
            $pak_weight=modApiFunc("Shipping_Cost_Calculator","getPackWeight");

            $_rates=array();
            $cmethods=array();

            $DSTcountry=modApiFunc("Location","getCountryCode",$ShippingInfo["validatedData"]["Country"]["value"]);

            if($ShippingInfo["isMet"]!=false)
            {
                $_rates=$this->calculate_rates($ShippingInfo,$pak_weight);
            };

            if(!empty($_rates))
            {
                foreach($_rates as $service => $sdata)
                {
                    foreach($methods as $key => $method)
                    {
                        if(strstr($method['method_name'],$service))
                        {
                            if(($method['destination']=="L" and $DSTcountry=="CA")
                                or ($method['destination']=="I" and $DSTcountry!="CA"))
                                $cmethods[]=array_merge($method,$sdata);
                        };
                    };
                };
            };

            $methods=$cmethods;

            $this->saveRatesToCache($ShippingInfo,$pak_weight,$methods);
        };


        return $methods;
    }

    /**
     * @param $update_array array if the IDs of the available methods,
     *      all other methods will be set to 'not available'
     */
    function updateShippingMethods($update_array)
    {
        global $application;

        $tables=$this->getTables();
        $methods_table=$tables['sm_cpc_methods']['columns'];

        $query = new DB_Update('sm_cpc_methods');
        $query->addUpdateValue($methods_table['available'],"N");
        $application->db->getDB_Result($query);

        if(count($update_array)==0 or !is_array($update_array))
            return;

        $query = new DB_Update('sm_cpc_methods');
        $query->addUpdateValue($methods_table['available'],"Y");
        $query->Where($methods_table['id'], DB_IN, "('".implode("','",array_keys($update_array))."')");
        $application->db->getDB_Result($query);

        return;
    }

    /**
     * @param $s_info shipping info of the destination
     * @param $weight weight of the package
     * @param $rates array of the shipping rates for saving
     */
    function saveRatesToCache($s_info,$weight,$rates)
    {
        if($s_info["isMet"]==false or empty($rates))
            return;

        $s_country=modApiFunc("Location","getCountry",$s_info["validatedData"]["Country"]["value"]);
        $s_zipcode=$s_info["validatedData"]["Postcode"]["value"];
        $s_name = isset($s_info["validatedData"]["Firstname"]["value"]) ? $s_info["validatedData"]["Firstname"]["value"] : '';
        $s_name.= isset($s_info["validatedData"]["Lastname"]["value"])  ? $s_info["validatedData"]["Lastname"]["value"]  : '';

        $hash=md5($s_country.$s_name.$s_zipcode.$weight);

        $tables=$this->getTables();
        $rc_table=$tables['sm_cpc_rates_cache']['columns'];

        global $application;

        $query = new DB_Delete('sm_cpc_rates_cache');
        $query->Where($rc_table['hash'], DB_EQ, "'$hash'");
        $application->db->getDB_Result($query);

        $query = new DB_Delete('sm_cpc_rates_cache');
        $query->Where($rc_table['expire'], DB_LT, time());
        $application->db->getDB_Result($query);

        foreach($rates as $key => $rate_info)
        {
            $query = new DB_Insert('sm_cpc_rates_cache');
            $query->addInsertValue($hash, $rc_table["hash"]);
            $query->addInsertValue($rate_info["id"],$rc_table["method_id"]);
            $query->addInsertValue($rate_info["cost"],$rc_table["rate"]);
            $query->addInsertValue(time()+18000,$rc_table["expire"]);
            $application->db->getDB_Result($query);
        };

        return;
    }

    /**
     * @param $s_info shipping info of the destination
     * @param $weight weight of the package
     * @param $method_id ID of the required shipping method
     * @return cost of the shipping from the cache
     *      or false if the requested cost is not saved in the cache
     */
    function getRateFromCache($s_info,$weight,$method_id)
    {
        if($s_info["isMet"]==false or !is_numeric($method_id))
            return false;

        $s_country=modApiFunc("Location","getCountry",$s_info["validatedData"]["Country"]["value"]);
        $s_zipcode=$s_info["validatedData"]["Postcode"]["value"];
        $s_name = isset($s_info["validatedData"]["Firstname"]["value"]) ? $s_info["validatedData"]["Firstname"]["value"] : '';
        $s_name.= isset($s_info["validatedData"]["Lastname"]["value"])  ? $s_info["validatedData"]["Lastname"]["value"]  : '';

        $hash=md5($s_country.$s_name.$s_zipcode.$weight);

        $tables=$this->getTables();
        $rc_table=$tables['sm_cpc_rates_cache']['columns'];

        $cached = execQuery('SELECT_SM_CPC_METHODS_CACHED',array('ApiClassName' => __CLASS__, 'hash' => $hash, 'method_id' => $method_id));

        if(isset($cached[0]["rate"]))
            return $cached[0]["rate"];
        else
            return false;
    }

    /**
     * @param $ShippingInfo shipping info of the destination
     * @param $pak_weight weight of the package
     * @return array of the shipping rates arrays
     */
    function calculate_rates($ShippingInfo, $pak_weight)
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"shipping-module-cpc-messages", "AdminZone");

        if($this->is_debug==true)
            $this->_debug_info[]=array("Calculate Type","Real-Time");

        $_rates = array();

        # get settings of the module
        $Settings=$this->getSettings();

        # calculate today midnight time by unix timestamp
        $today = getdate();
        $today_midnight = mktime(0,0,0,$today['mon'],$today['mday'],$today['year']);

        # choose the rate server
        if($Settings["USE_TEST_SERVER"]=="NO")
            $rate_server_url = $application->getAppIni('CPC_LIVE_SERVER_URL');
        else
            $rate_server_url = $application->getAppIni('CPC_TEST_SERVER_URL');

        # receive Merchant ID from the Settings
        $merchant_id=$Settings["MERCHANT_ID"];

        # receive origination zip, destination country, zip, state
        $ozip = modApiFunc("Configuration","getTagValue","StoreOwnerPostcode");
        $dcntr = modApiFunc("Location","getCountryCode",$ShippingInfo["validatedData"]["Country"]["value"]);
        if($dcntr=="CA")
            $dzip = $ShippingInfo["validatedData"]["Postcode"]["value"];
        else
            $dzip=" ";
        if($dcntr=="CA" or $dcntr=="US" && !empty($ShippingInfo["validatedData"]["Statemenu"]["value"]))
            $dstate = modApiFunc("Location","getStateCode",$ShippingInfo["validatedData"]["Statemenu"]["value"]);
        else
            $dstate=" ";

        # get cost of the all products in the cart
        /*
        if($this->is_debug==true)
            $cartTotal = modApiFunc("Shipping_Tester","getCartSubtotal");
        else
            $cartTotal = modApiFunc("Checkout", "getOrderPrice", "Subtotal");
        *///@ here!
        $main_currency_id = modApiFunc("Localization", "getMainStoreCurrency");
        $main_currency_code = modApiFunc("Localization", "getCurrencyCodeById", $main_currency_id);
        $cartTotal = modApiFunc("Shipping_Cost_Calculator", "getCartSubtotal");

        // convert cartTotal to CAD, if necessary
        if ($main_currency_code != "CAD")
        {
            if(modApiFunc('Currency_Converter', 'isConvertAvail', $main_currency_code, "CAD"))
            {
                $newCartTotal = modApiFunc('Currency_Converter', 'convert', $cartTotal, $main_currency_code, "CAD");

                if($this->is_debug == true)
                {
                    $msg = $this->MessageResources->getMessage('LABEL_CONVERTING');
                    $this->_debug_info[] = array($msg, "{$main_currency_code} -> CAD: {$cartTotal} -> {$newCartTotal}");
                }

                $cartTotal = $newCartTotal;
            }
            else
            {
                //                                 ->                  .
                if($this->is_debug == true)
                {
                    $msg = $this->MessageResources->getMessage('ERROR_014');
                    $this->_debug_info[] = array('Error', $msg);
                }

                return $_rates;
            }
        }

        # calculate weight in the kilogramms
        $local_wcoeff = modApiFunc("Localization","getValue","WEIGHT_COEFF");
        $weight = round($pak_weight * $local_wcoeff, 3);

        if($weight < 1)
            $weight = 1;

        # receive package sizes from the Settings
        $length=$Settings["PK_LENGTH"];
        $width=$Settings["PK_WIDTH"];
        $height=$Settings["PK_HEIGHT"];

        if($this->is_debug==true)
        {
            $this->_debug_info[]=array("Destination Country Code",$dcntr);
            $this->_debug_info[]=array("Destination Zip",$dzip);
            $this->_debug_info[]=array("Service URL is",$rate_server_url);
        };

        # generate XML-request
        $xml_request="".
        "<?xml version=\"1.0\" ?>".
        "<eparcel>".
            "<language>en</language>".
            "<ratesAndServicesRequest>".
                "<merchantCPCID>$merchant_id</merchantCPCID>".
                "<fromPostalCode>$ozip</fromPostalCode>".
                "<itemsPrice>$cartTotal</itemsPrice>".
                "<lineItems>".
                    "<item>".
                        "<quantity>1</quantity>".
                        "<weight>$weight</weight>".
                        "<length>$length</length>".
                        "<width>$width</width>".
                        "<height>$length</height>".
                        "<description>All products package</description>".
                        "<readyToShip/>".
                    "</item>".
                "</lineItems>".
                "<provOrState>$dstate</provOrState>".
                "<country>$dcntr</country>".
                "<postalCode>$dzip</postalCode>".
            "</ratesAndServicesRequest>".
        "</eparcel>";

        if($this->is_debug==true)
            $this->_debug_info[]=array("XML Request",$xml_request);

        # send XML-request to the rate server
        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod("POST");
        $bnc->setHTTPversion($application->getAppIni('CPC_HTTP_PROTOCOL_VERSION'));
        $bnc->setURL($rate_server_url);
        $bnc->setPOSTstring($xml_request);

        # get response
        $res = $bnc->RunRequest();

        if($res!=false)
        {
            $xml_response = $res["body"];

            if($this->is_debug==true)
                $this->_debug_info[]=array("XML Response",$xml_response);

            # parse the XML-response
            loadCoreFile('obj_xml.php');
            $parser = new xml_doc($xml_response);
            $parser->parse();

            $rate_response=@$parser->xml_index[0]->children[0]->children;

            if (is_array($rate_response))
            {
                foreach($rate_response as $k => $rinfo)
                {
                    if($rinfo->name=="PRODUCT")
                    {
                        $_service=""; # name of the service
                        $_rate="";    # cost of the service
                        $_days=0;     # delivery time of the service
                        foreach($rinfo->children as $ck => $cinfo)
                            if($cinfo->name=="NAME")
                                $_service=$cinfo->contents;
                            elseif($cinfo->name=="RATE")
                                $_rate=$cinfo->contents;
                            elseif($cinfo->name=="DELIVERYDATE")
                            {
                                if(preg_match("/^[0-9]{4}-[0-9]{2}-[0-9]{2}/",$cinfo->contents))
                                {
                                    # if delivery date has YYYY-MM-DD format
                                    # calculate delivery days
                                    $da=explode("-",$cinfo->contents);
                                    $dd_midnight = mktime(0,0,0,$da[1],$da[2],$da[0]);
                                    $_days = round(($dd_midnight - $today_midnight) / 86400);
                                }
                                else
                                    # if delivery date is string with the desription (i.e. '7 to 12 days')
                                    # put into $_days as is
                                    $_days = $cinfo->contents;
                            };
                        $_rates[$_service]=array("cost"=>$_rate,"days"=>$_days);
                    }
                    elseif($rinfo->name=="STATUSCODE" and $this->is_debug==true)
                    {
                        if($rinfo->contents!="1")
                            $this->_debug_info[]=array("Error code",$rinfo->contents);
                    }
                    elseif($rinfo->name=="STATUSMESSAGE" and $this->is_debug==true)
                    {
                        if($rinfo->contents!="OK")
                            $this->_debug_info[]=array("Error message",$rinfo->contents);
                    }
                };
            }
        }
        elseif($this->is_debug==true)
            $this->_debug_info[]=array("Error", $bnc->getLastErrorMessage());

        // convert rates from CAD to the main store currency, if necessary
        if ($main_currency_code != "CAD")
        {
            foreach ($_rates as $key => $value)
            {
                $_rates[$key]["cost"] = modApiFunc('Currency_Converter', 'convert', $value["cost"], "CAD", $main_currency_code);

                if($this->is_debug == true)
                {
                    $msg = $this->MessageResources->getMessage('LABEL_CONVERTING');
                    $this->_debug_info[] = array($msg, "CAD -> {$main_currency_code}: {$value["cost"]} -> {$_rates[$key]["cost"]}");
                }
            }
        }

        return $_rates;
    }

    function setDebugFlag($flag=true)
    {
        if(is_bool($flag))
            $this->is_debug=$flag;
    }

    function getDebugInfo()
    {
        return $this->_debug_info;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * @param $method_id ID of shipping method of this module
     * @return shipping cost or PRICE_N_A
     */
    function getShippingCost($method_id="")
    {
        $ShippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
        $pak_weight=modApiFunc("Checkout", "getOrderWeight", "netto");
        $rate=$this->getRateFromCache($ShippingInfo,$pak_weight,$method_id);
        if($rate!=false)
            return $rate;
        else
            return PRICE_N_A;
    }

    var $bActive;

    var $is_debug;
    var $_debug_info;

    /**#@-*/
}
?>