<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * cpc_input_az view
 *
 * @package ShippingModuleCPC
 * @author Egor V. Derevyankin
 */
class cpc_input_az extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Modules_Manager constructor.
     */
    function cpc_input_az()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"shipping-module-cpc-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->shipping_methods=modApiFunc("Shipping_Module_CPC","getShippingMethods");

        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }

        $requirments=modApiFunc("Shipping_Module_CPC","checkRequirments");
        $reqsErrors=array("OCNTR"=>"ERROR_007","CURRENCY"=>"ERROR_008");
        for($i=0;$i<count($requirments);$i++)
            $this->ErrorsArray[]=$reqsErrors[$requirments[$i]];

        if(count($this->ErrorsArray)>0 and $this->POST["status"]==true)
        {
            $this->POST["status"]=false;
            $this->ViewState["hasCloseScript"]="false";
        };

    }

    /**
     * Copies data from the global POST to the local POST array.
     */
    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST =
            array(
                "ModuleName"    => $SessionPost["ModuleName"]
               ,"status"        => ($SessionPost["status"]=="active")? true:false
               ,"UseTestServer" => $SessionPost["UseTestServer"]
               ,"MerchantID"    => $SessionPost["MerchantID"]
               ,"PK_HEIGHT"     => $SessionPost["pk_height"]
               ,"PK_WIDTH"      => $SessionPost["pk_width"]
               ,"PK_LENGTH"     => $SessionPost["pk_length"]
               ,"SMethodsAvailable" => array()
            );

        if(is_array($this->shipping_methods) and !empty($this->shipping_methods))
            foreach($this->shipping_methods as $key => $method)
                $this->POST["SMethodsAvailable"][$method['id']] =
                    (isset($SessionPost["SMethodsAvailable"][$method['id']])?"Y":"N");

    }

    /**
     * Fills the local POST array with data from the DB.
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Shipping_Module_CPC", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME":     $this->POST["ModuleName"] = $value;     break;
                case "USE_TEST_SERVER": $this->POST["UseTestServer"] = $value;  break;
                case "MERCHANT_ID":     $this->POST["MerchantID"] = $value;     break;
                case "PK_HEIGHT":       $this->POST["PK_HEIGHT"] = $value;      break;
                case "PK_WIDTH":        $this->POST["PK_WIDTH"] = $value;       break;
                case "PK_LENGTH":       $this->POST["PK_LENGTH"] = $value;      break;
            }
        }
        $this->POST["status"] = modApiFunc("Shipping_Module_CPC", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );

        $this->POST["SMethodsAvailable"]=array();
        if(is_array($this->shipping_methods) and !empty($this->shipping_methods))
            foreach($this->shipping_methods as $key => $method)
                $this->POST["SMethodsAvailable"][$method["id"]]=$method["available"];

    }


    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * @return HTML code for the errors
     */
    function outputErrors()
    {
        global $application;

        $return_html_code="";

        foreach($this->ErrorsArray as $index => $value)
        {
            $this->_Template_Contents = array(
                                            "ErrorIndex"    => $index+1,
                                            "Error"         => $this->MessageResources->getMessage($value)
                                        );
            $application->registerAttributes($this->_Template_Contents);
            $return_html_code.=$this->mTmplFiller->fill("shipping_module_fedex/", "error.tpl.html", array());
        };

        return $return_html_code;
    }

    function outputTopErrors()
    {
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }

        global $application;

        $return_html_code="";

        $this->_Template_Contents = array(
                                            "Errors"    => $this->outputErrors()
                                        );
        $application->registerAttributes($this->_Template_Contents);
        $return_html_code.=$this->mTmplFiller->fill("shipping_module_fedex/", "errors.tpl.html", array());

        return $return_html_code;
    }

    /**
     * @return HTML code for the module status
     */
    function outputStatus()
    {
        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("shipping_module_cpc/", "status.tpl.html", array());
        return $retval;
    }

    /**
     * @return HTML code for the 'available' checkbox for the shipping method
     */
     function outputAvailableCheckBox($checkbox_id,$available)
    {
        $is_checked=($available=="Y"?"checked":"");
        $return_html_code = "<input type=\"checkbox\" id=\"MA-$checkbox_id\" name=\"SMethodsAvailable[$checkbox_id]\" $is_checked>";
        return $return_html_code;
    }

    /**
     * @return HTML code for the list of the shipping methods
     */
    function outputShippingMethods()
    {
        global $application;

        if(empty($this->shipping_methods) or !is_array($this->shipping_methods))
            return $this->MessageResources->getMessage('LABEL_NO_SHIPPING_METHODS');

        $return_html_code="";

        foreach($this->shipping_methods as $method_key => $method_info)
        {
            $dest=$method_info['destination']=="L"?$this->MessageResources->getMessage("LABEL_SM_DESTINATION_NATIONAL"):
                $this->MessageResources->getMessage("LABEL_SM_DESTINATION_INTERNATIONAL");

            $this->_Template_Contents=array (
                "CycleColor"                   => ( $method_key % 2 ? "EEEEEE":"FFFFFF"),
                "SMethodName"                  => $method_info['method_name'],
                "SMethodDestination"           => $dest,
                "SMethodAvailableCheckBox"     => $this->outputAvailableCheckBox($method_info['id'],$this->POST["SMethodsAvailable"][$method_info['id']])
            );
            $application->registerAttributes($this->_Template_Contents);
            $return_html_code.=$this->mTmplFiller->fill("shipping_module_cpc/","methods_list_item.tpl.html",array());
        }

        return $return_html_code;
    }


    /**
     * @return HTML code for this view
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        $use_tst_srvr = array(
                "select_name" => "UseTestServer",
                "selected_value" => $this->POST["UseTestServer"],
                "values" => array(
                        array(
                            "value" => "YES",
                            "contents" => $this->MessageResources->getMessage('LABEL_YES'),
                        ),
                        array(
                            "value" => "NO",
                            "contents" => $this->MessageResources->getMessage('LABEL_NO'),
                        ),
                    ),
        );


        $request = new Request();
        $request->setView('CheckoutShippingModuleSettings');
        $request->setAction("update_cpc_settings");
        $form_action = $request->getURL();
        $settings = modApiFunc("Shipping_Module_CPC", "getSettings");
        $template_contents = array(
                                    "EditSMForm"    => $HtmlForm1->genForm($form_action, "POST", "EditSMForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"TopErrors"             => $this->outputTopErrors()
                                   ,"ModuleStatusFieldName" => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                                   ,"ModuleStatusField"     => $this->outputStatus()
                                   ,"ModuleNameFieldName"   => $this->MessageResources->getMessage('MODULE_NAME_FIELD_NAME')
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "ModuleName", "75", prepareHTMLDisplay($this->POST["ModuleName"]))
                                   ,"ModuleDescrFieldName"  => $this->MessageResources->getMessage('MODULE_DESCR_FIELD_NAME')
                                   ,"ModuleDescrFieldValue" => $this->MessageResources->getMessage('MODULE_DESCR')
                                   ,"CalculationHeader"     => $this->MessageResources->getMessage('LABEL_CALCULATION_HEADER')
                                   ,"UseTestServerFieldName" => $this->MessageResources->getMessage('LABEL_USE_TEST_SERVER')
                                   ,"UseTestServerField"    => $HtmlForm1->genDropdownSingleChoice($use_tst_srvr)
                                   ,"MerchantIDFieldName"   => $this->MessageResources->getMessage('LABEL_MERCHANT_ID')
                                   ,"MerchantIDField"       => $HtmlForm1->genInputTextField("128","MerchantID","75",prepareHTMLDisplay($this->POST["MerchantID"]))
                                   ,"PackageSizesHeader"    => $this->MessageResources->getMessage('PK_SIZES_HEADER')
                                   ,"PKH_Name"              => $this->MessageResources->getMessage('PK_HEIGHT')
                                   ,"PKH_Field"             => $HtmlForm1->genInputTextField("128","pk_height","75",$this->POST["PK_HEIGHT"])
                                   ,"PKW_Name"              => $this->MessageResources->getMessage('PK_WIDTH')
                                   ,"PKW_Field"             => $HtmlForm1->genInputTextField("128","pk_width","75",$this->POST["PK_WIDTH"])
                                   ,"PKL_Name"              => $this->MessageResources->getMessage('PK_LENGTH')
                                   ,"PKL_Field"             => $HtmlForm1->genInputTextField("128","pk_length","75",$this->POST["PK_LENGTH"])
                                   ,"MethodsHeader"         => $this->MessageResources->getMessage('METHODS_HEADER')
                                   ,"MethodsList"           => $this->outputShippingMethods()
                                   ,"LabelSMName"           => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_NAME')
                                   ,"LabelSMDestination"    => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_DESTINATION')
                                   ,"LabelSMAvailable"      => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_AVAILABLE')
                                   ,"MethodsCount"          => count($this->shipping_methods)
                                   ,"Alert_001"             => $this->MessageResources->getMessage('ALERT_001')
                                   ,"Alert_002"             => $this->MessageResources->getMessage('ALERT_002')
                                   ,"Alert_003"             => $this->MessageResources->getMessage('ALERT_003')
                                   ,"Alert_004"             => $this->MessageResources->getMessage('ALERT_004')
                                   ,"Alert_005"             => $this->MessageResources->getMessage('ALERT_005')
                                   ,"Alert_006"             => $this->MessageResources->getMessage('ALERT_006')
                                   ,"HintLink_MID"          => $this->Hints->getHintLink(array('LABEL_MERCHANT_ID','shipping-module-cpc-messages'))
                                   ,"HintLink_UTS"          => $this->Hints->getHintLink(array('LABEL_USE_TEST_SERVER','shipping-module-cpc-messages'))
                                   ,"HintLink_PKH"          => $this->Hints->getHintLink(array('PK_HEIGHT','shipping-module-cpc-messages'))
                                   ,"HintLink_PKW"          => $this->Hints->getHintLink(array('PK_WIDTH','shipping-module-cpc-messages'))
                                   ,"HintLink_PKL"          => $this->Hints->getHintLink(array('PK_LENGTH','shipping-module-cpc-messages'))
                                  );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("shipping_module_cpc/", "list.tpl.html",array());
    }

    /**
     * @param $tag name of the requested tag
     * @return value of the tag
     */
    function getTag($tag)
    {
        global $application;
        $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;

    /**
     * View state structure. It comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    var $shipping_methods;

    /**#@-*/
}
?>