<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package ShippingModuleInterShipper
 * @access  public
 * @author Egor V. Derevyankin
 */
class update_intershipper_settings extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_intershipper_settings()
    {
    }

    /**
     * @param $SessionPost array of the posted params
     */
    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Shipping_Module_InterShipper", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array(
                          "MODULE_NAME"     => $SessionPost["ModuleName"],
                          "USERNAME"        => $SessionPost["Username"],
                          "PASSWORD"        => $SessionPost["Password"],
                          "DELIVERY_TYPE"   => $SessionPost["DeliveryType"],
                          "PICKUP_TYPE"     => $SessionPost["PickupType"],
                          "PK_HEIGHT"       => $SessionPost["pk_height"],
                          "PK_WIDTH"        => $SessionPost["pk_width"],
                          "PK_LENGTH"       => $SessionPost["pk_length"],
                         );

        modApiFunc("Shipping_Module_InterShipper", "updateSettings", $Settings);

        $Methods = array();

        if(isset($SessionPost["SMethodsAvailable"]) and is_array($SessionPost["SMethodsAvailable"]))
            $Methods=$SessionPost["SMethodsAvailable"];

        modApiFunc("Shipping_Module_InterShipper", "updateShippingMethods", $Methods);
    }

    /**
     * Action processor.
     */
    function onAction()
    {
        global $application;
        $request = $application->getInstance('Request');

        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        $SessionPost["ViewState"]["ErrorsArray"] = array();

        if($SessionPost["status"] == "active")
        {
            //         ,       CheckoutFormEditor'
            //         PersonInfo     : ShippingInfo.
            if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("shippingInfo")) === true)
            {
            }
            else
            {
                $SessionPost["status"]= "inactive";
                $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
            }
        }

        if($SessionPost["ModuleName"]=="")
            $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_001";

        if($SessionPost["status"]=="active")
        {
            if(trim($SessionPost["Username"])=="")
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_008";

            if(trim($SessionPost["Password"])=="")
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_009";

            if(!isset($SessionPost["SMethodsAvailable"]) or empty($SessionPost["SMethodsAvailable"]))
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_002";

            $SessionPost["pk_height"]=intval(trim($SessionPost["pk_height"]));
            $SessionPost["pk_width"]=intval(trim($SessionPost["pk_width"]));
            $SessionPost["pk_length"]=intval(trim($SessionPost["pk_length"]));

            if($SessionPost["pk_height"]<=0)
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_003";

            if($SessionPost["pk_width"]<=0)
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_004";

            if($SessionPost["pk_length"]<=0)
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_005";

        };

        if($SessionPost["ViewState"]["FormSubmitValue"]=="Save")
        {
            if(count($SessionPost["ViewState"]["ErrorsArray"])==0
                and count(modApiFunc("Shipping_Module_InterShipper","checkRequirments"))==0)
            {
                unset($SessionPost["ViewState"]["ErrorsArray"]);
                $this->saveDataToDB($SessionPost);
                $SessionPost["ViewState"]["hasCloseScript"] = "true";
            };
        };

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>